////////////////////////////////////////////////////////////////////////
//	@file sdlgames.cpp 
//	@brief 
//	@author Laurent Cance <lcf@tlk.fr> 
//	@copyright 2008 TLK Games
//	@date 2010-09-06 
//	$Author: bruno $
//	$Date: 2008-12-19 11:05:15 +0100 (ven 19 d√©c 2008) $
//	$Id: games.h 328 2008-12-19 10:05:15Z bruno $
//	$Revision: 328 $
////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdarg.h>
#include "base/params.h"
#include "base/tools.h"

int SETMOUSECURSOR=0;
int CD_REMOVED=0;
bool Timer_TICK = false;
float GAMES_RATIO=1.0f;


int _CX,_CY;
int TAG_WINDOWED;


FILE * flog;

#define LOG


void NewLog()
{
#ifdef LOG
	flog=fopen("log.txt","w");
	fclose(flog);
#endif
}

void AddLog(const char * str)
{
#ifdef LOG
	flog=fopen("log.txt","a");
	fprintf(flog,"%s\n",str);
	fclose(flog);
#endif
}

#ifndef API3D_SDL_OPENGL
//----------------------------------------------------------------------------------------------------------- DIRECT3D -
#include <windows.h>
#include <io.h>
#include <conio.h>

int		WX=900;
int		WY=700;
int		SCREEN_MAX_X=1024;
float	SCREEN_RATIO=1.0f;

static bool windowed=false;

static bool moving=true;

static char Name[1024];
static const char * stringNameOfGame=Name;


LARGE_INTEGER Temps1,Temps2;
LARGE_INTEGER freq;


HINSTANCE hInstance;
HWND hWnd;
int TabKeys[512];
int Bouton[2];
int xMouse,yMouse;

bool KeyDown,KeyUp;
int LastKeyDown;

bool Capital=false;

bool bActive;
bool fActive;
bool fMinimized;
int WHEEL=0;

extern void GAMES_ACTIVATE_PROC(bool fm,bool fa);

void AddLog(char *str);

bool MovingCapital=false;
bool FixedCapital=false;

void Main_OnDeviceChange (HWND hwnd, WPARAM wParam, LPARAM lParam);

long FAR PASCAL
WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	POINT	MousePoint;
	BOOL bActiveApp;
	WHEEL=0;

	if (FixedCapital) Capital=true;
	else Capital=false;

	if (MovingCapital) Capital=true;

    switch (message)
    {
		case WM_DEVICECHANGE:
#ifdef HANDLING_CDROM
			Main_OnDeviceChange (hWnd,wParam,lParam);
#endif
		break;
        case WM_ACTIVATE:

            bActive = ((HIWORD(wParam))==0);
			fActive = (LOWORD(wParam)!=0);
			fMinimized = (bool) (HIWORD(wParam)!=0); 


			GAMES_ACTIVATE_PROC(fMinimized,fActive);

            return 0L;

        case WM_ACTIVATEAPP:
            // Pause if minimized
            bActiveApp = !((BOOL)HIWORD(wParam));

            return 0L;

        case WM_DESTROY:
            // Clean up and close the app
            //KillDIRECTDRAW();
            PostQuitMessage(0);
            return 0L;

		 case 0x020A:

            // 
            // Mouse Wheel is being rolled forward 
            // 
            if( (short)HIWORD(wParam) > 0 ) WHEEL=-1;     
                
            // 
            // Mouse Wheel is being rolled backward 
            // 
            if( (short)HIWORD(wParam) < 0 ) WHEEL=1;
 
            break; 


	    case WM_LBUTTONDOWN:
		    Bouton[0]=1;
			break;
        
		case WM_LBUTTONUP:
			Bouton[0]=0;
			break;

		case WM_RBUTTONDOWN:
	        Bouton[1]=1;
			break;
        
		case WM_RBUTTONUP:
	        Bouton[1]=0;
			break;

        
		case WM_MOUSEMOVE:
         {
             GetCursorPos(&MousePoint);
             xMouse=MousePoint.x;
             yMouse=MousePoint.y;

			 if (moving)
			 {
				 MousePoint.x=WX/2;
				 MousePoint.y=WY/2;
//				 SetCursorPos(MousePoint.x,MousePoint.y);
		 
			 }
         }
		 break;


/*
		case WM_KEYUP:
			TabKeys[wParam]=0;
		break;    

        case WM_KEYDOWN:
			TabKeys[wParam]=1;
			if (wParam==VK_F12) PostMessage(hWnd, WM_QUIT, 0, 0);
            break;
*/
		case WM_KEYUP:
			KeyUp=true;
			TabKeys[wParam]=0;
			if (TabKeys[16]) MovingCapital=true;
			else MovingCapital=false;
			if (TabKeys[VK_LSHIFT]) MovingCapital=true;
			if (TabKeys[VK_RSHIFT]) MovingCapital=true;

			if (MovingCapital) Capital=true;

		break;    

        case WM_KEYDOWN:
/*
			{
				char ss[128];
				sprintf(ss,"key=%d",wParam);
				AddLog(ss);
			}
*/

			if (wParam==VK_UP) WHEEL=-1;
			if (wParam==VK_DOWN) WHEEL=1;


			TabKeys[wParam]=1;
			if (wParam==VK_F12) PostMessage(hWnd, WM_QUIT, 0, 0);

			KeyDown=true;
			LastKeyDown=wParam;
			if ((wParam>=0x6A)&&(wParam<0x87)) KeyDown=false;

			if (TabKeys[16]) MovingCapital=true;
			else MovingCapital=false;
			if (TabKeys[VK_LSHIFT]) MovingCapital=true;
			if (TabKeys[VK_RSHIFT]) MovingCapital=true;

			if (MovingCapital) Capital=true;


			if ((LastKeyDown>='0')&&(LastKeyDown<='9')&&(Capital))
			{
				switch (LastKeyDown)
				{
				case '0':
					LastKeyDown='‡';
					break;
				case '1':
					KeyDown=false;
					break;
				case '2':
					LastKeyDown='È';
					break;
				case '3':
					LastKeyDown='"';
					break;
				case '4':
					LastKeyDown='\'';
					break;
				case '5':
					LastKeyDown='(';
					break;
				case '6':
					LastKeyDown='-';
					break;
				case '7':
					LastKeyDown='Ë';
					break;
				case '8':
					KeyDown=false;
					break;
				case '9':
					LastKeyDown='Á';
					break;
				};
			}

			if ((wParam==219)&&(Capital))
			{
				LastKeyDown=')';
				KeyDown=true;
			}

			if (wParam==191)
			{
				if (Capital)
				{
					LastKeyDown='/';
					KeyDown=true;
				}
				else
				{
					LastKeyDown=':';
					KeyDown=true;
				}
			}

			if (wParam==187)
			{
				if (Capital)
				{
					LastKeyDown='+';
					KeyDown=true;
				}
				else
				{
					LastKeyDown='=';
					KeyDown=true;
				}
			}


			switch (wParam)
			{
			case 223:
				LastKeyDown='!';
				break;

			case VK_DECIMAL:
			case 190:
				if (Capital)
				{
					KeyDown=true;
					LastKeyDown=';';
				}
				else
				{
					KeyDown=true;
					LastKeyDown='.';
				}
				break;

			case 188:
				if (Capital) LastKeyDown='?'; else LastKeyDown=',';
				break;

			case VK_NUMPAD0:
				LastKeyDown='0';
				break;    
			case VK_NUMPAD1:
				LastKeyDown='1';
				break;    
			case VK_NUMPAD2:
				LastKeyDown='2';
				break;    
			case VK_NUMPAD3:
				LastKeyDown='3';
				break;    
			case VK_NUMPAD4:
				LastKeyDown='4';
				break;    
			case VK_NUMPAD5:
				LastKeyDown='5';
				break;    
			case VK_NUMPAD6:
				LastKeyDown='6';
				break;    
			case VK_NUMPAD7:
				LastKeyDown='7';
				break;    
			case VK_NUMPAD8:
				LastKeyDown='8';
				 break;    
			case VK_NUMPAD9:
				LastKeyDown='9';
				break;    

			case VK_LSHIFT:
			case VK_RSHIFT:
			case VK_PRIOR:
			case VK_NEXT:
			case VK_END:
			case VK_HOME:
			case VK_TAB:
				KeyDown=false;
				break;

			case VK_CAPITAL:
				if (FixedCapital) FixedCapital=false; else FixedCapital=true;
				
				break;

			};
			break;


        case WM_SETCURSOR:
            SetCursor(NULL);
            return TRUE;
    }
    return DefWindowProc(hWnd, message, wParam, lParam);
}

extern void GAMES_PROGRAMME_PRINCIPAL();

LARGE_INTEGER T_Start,T_Actual;
LARGE_INTEGER T_freq;

void StartTimeCounter()
{
	QueryPerformanceFrequency(&T_freq);
	QueryPerformanceCounter(&T_Start);
}

unsigned int GetTicks()
{
	unsigned int gtc;
	LONGLONG dT;

	QueryPerformanceCounter(&T_Actual);
	dT=T_Actual.QuadPart - T_Start.QuadPart;
	gtc=(unsigned int) ((1000*dT)/T_freq.QuadPart);

	return gtc;
}


INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT nCmdShow)
{
    // Register the window class
	GetPrivateProfileString("Name","WindowName","3D Brick Blaster",Name,1024,"data/gamename.ini");

	hInstance=hInst;
    WNDCLASS wndClass = { (CS_HREDRAW | CS_VREDRAW)*0, WindowProc, 0, 0, hInst,
                          NULL,NULL,
                          (HBRUSH)GetStockObject(BLACK_BRUSH), NULL,
                          TEXT(stringNameOfGame) };
    RegisterClass( &wndClass );
 
    // Create our main window

	RECT rr;
	GetClientRect(GetDesktopWindow(), &rr);

	SCREEN_MAX_X=rr.right-rr.left;
	if (SCREEN_MAX_X<800) SCREEN_MAX_X=800;

	float wx,wy;

	wx=(float)(rr.right-rr.left);
	wy=(float)(rr.bottom-rr.top);

	SCREEN_RATIO=(wx/wy)/1.25f;

	if (!windowed)
	{

    hWnd = CreateWindow( TEXT(stringNameOfGame),
                              TEXT(stringNameOfGame),
                              WS_POPUP, 0,0,
                              rr.right-rr.left,  rr.bottom-rr.top, 0L, 0L, hInst, 0L );
	}
	else
	{
    hWnd = CreateWindow( TEXT(stringNameOfGame),
                              TEXT(stringNameOfGame),
                              WS_OVERLAPPEDWINDOW, 50,50,
                              WX, WY, 0L, 0L, hInst, 0L );
	}
	ShowWindow(hWnd, nCmdShow);
    UpdateWindow( hWnd );


	int n;
	for (n=0;n<256;n++) TabKeys[n]=0;

	StartTimeCounter();
	GAMES_PROGRAMME_PRINCIPAL();


	PostMessage(hWnd, WM_CLOSE, 0, 0);
	return (0);
}


bool ReadEvents()
{
	MSG msg;

	WHEEL=0;
	if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
	{
		if( !GetMessage( &msg, NULL, 0, 0 ) ) return true;
			
		TranslateMessage(&msg); 
		DispatchMessage(&msg);
	}
	else
	{
		if (msg.message==WM_QUIT) return false;
	}

	return true;
}


void TimeInit()
{
	QueryPerformanceFrequency(&freq);
	QueryPerformanceCounter(&Temps1);
}

float TimeGet()
{
	float dt,f;
	LONGLONG dT;

	QueryPerformanceCounter(&Temps2);
	dT=Temps2.QuadPart - Temps1.QuadPart;
	f=(float) (1000*dT)/freq.QuadPart;
	Temps1=Temps2;
	dt=(f/17);

	return dt;
}
#else
//----------------------------------------------------------------------------------------------------------- SDL ------

	#ifdef __gnu_linux__
		#include <SDL/SDL.h>
	#else
		#include <SDL/SDL.h>
		#ifdef WIN32
			#include <windows.h>
		#endif
		
	#endif


unsigned int lastTicks;
float anciendt=0;
float nouveaudt=0;

int TabKeys[512];
int Bouton[2];
int xMouse,yMouse;

int		WX=1024;
int		WY=768;
int		SCREEN_MAX_X=1024;
float	SCREEN_RATIO=1.0f;

//static char stringNameOfGame0[512];
static const char *stringNameOfGame;

bool KeyDown,KeyUp;
int LastKeyDown;

bool Capital=false;

bool bActive;
bool fActive;
bool fMinimized;
int WHEEL=0;

void SetMouse()
{
	/*
	 FIXME function to implement Linux
	 MousePoint.x=320;
	 MousePoint.y=240;
	 SetCursorPos(MousePoint.x,MousePoint.y);
	 */
}

extern void GAMES_PROGRAMME_PRINCIPAL();


void TimeInit()
{
	lastTicks=SDL_GetTicks();
}

#define COEF 0.2f

float TimeGet()
{
	float dt,f;
	Uint32 t2=SDL_GetTicks();
	nouveaudt=(float) (t2-lastTicks);
	f=nouveaudt;
	lastTicks=t2;
	dt=(f/20);
	anciendt=f;

	return dt;
}


unsigned int GetTicks()
{
	return 0;
}

int main(int argc,char * argv[])
{ 
	int n; 

	SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO);
	const SDL_VideoInfo* sdlVideoInfo = SDL_GetVideoInfo();
	//Laurent nous fait du SDL qui fonctionne que sous Windows!!!!
	//RECT rr;
	//GetClientRect(GetDesktopWindow(), &rr);
	//SCREEN_MAX_X=rr.right-rr.left;
	SCREEN_MAX_X=sdlVideoInfo->current_w;
	if (SCREEN_MAX_X<800) SCREEN_MAX_X=800;
	
	float wx,wy;
	

	//wx=rr.right-rr.left;
	//wy=rr.bottom-rr.top;
	wx=sdlVideoInfo->current_w;
	wy=sdlVideoInfo->current_h;

	SCREEN_RATIO=(wx/wy)/1.25f;

	stringNameOfGame="Program";

	SDL_EnableUNICODE(1);  

	for (n=0;n<1024;n++) TabKeys[n]=0;

	GAMES_PROGRAMME_PRINCIPAL();

	SDL_Quit(); 

	return 0; 
}

int axM,ayM;
 
bool ReadEvents()
{
	int W=0;
	bool res;
	SDL_Event event;
	// unused SDLMod mod;
	char ch;
	res=true;

	WHEEL=0;


	while (SDL_PollEvent(&event))
	{

		switch (event.type)
		{
		case SDL_KEYDOWN:
			TabKeys[event.key.keysym.sym]=1;


			if (event.key.keysym.sym==SDLK_UP) WHEEL=-1;
			if (event.key.keysym.sym==SDLK_DOWN) WHEEL=1;

			ch=event.key.keysym.sym;
			
			LastKeyDown=ch;
			KeyDown=false;
							
			if ((LastKeyDown>='a')&&(LastKeyDown<='z'))
			{
				KeyDown=true;
				if ((Capital)||(TabKeys[SDLK_LSHIFT])||(TabKeys[SDLK_RSHIFT])) LastKeyDown+='A'-'a';
			}
			
			if ((LastKeyDown>=SDLK_KP0)&&(LastKeyDown<=SDLK_KP9))
			{
				LastKeyDown=(LastKeyDown+'0')-SDLK_KP0;
				KeyDown=true; 
			}
			
			if (event.key.keysym.sym==SDLK_CAPSLOCK)
			{
				if (Capital) Capital=false; else Capital=true;
			}
			
			if (event.key.keysym.sym==SDLK_COMMA)
			{
				LastKeyDown=',';
				KeyDown=true;
			}	
			
			if ((event.key.keysym.sym==SDLK_PERIOD)||(event.key.keysym.sym==SDLK_SEMICOLON)||(event.key.keysym.sym==SDLK_KP_PERIOD))
			{
				LastKeyDown='.';
				KeyDown=true;
			}	
			
			if (event.key.keysym.sym==SDLK_QUESTION)
			{
				LastKeyDown='?';
				KeyDown=true;
			}
			
			if (event.key.keysym.sym==SDLK_BACKSPACE)
			{
				KeyDown=true;
				LastKeyDown=8;
			}

			if (event.key.keysym.sym==SDLK_SPACE)
			{
				KeyDown=true;
				LastKeyDown=' ';
			}

			
			if (event.key.keysym.sym==SDLK_RETURN)
			{
				KeyDown=true;
				LastKeyDown=13;
			}
			
			
			if ((LastKeyDown>='0')&&(LastKeyDown<='9'))
			{
				if (Capital)
				{
					switch (LastKeyDown)
					{
						case '2':
							LastKeyDown='È';
							KeyDown=true;
							break;
						case '4':
							LastKeyDown='\'';
							KeyDown=true;
							break;
						case '7':
							LastKeyDown='Ë';
							KeyDown=true;
							break;
						case '8':
							LastKeyDown='_';
							KeyDown=true;
							break;
						case '9':
							LastKeyDown='Á';
							KeyDown=true;
							break;
						case '0':
							LastKeyDown='‡';
							KeyDown=true;
							break;
					};
							
				}
				else
				{
					KeyDown=true;
				}
			}					

			if (event.key.keysym.sym==SDLK_F12) res=false;
			break;

		case SDL_KEYUP:
			TabKeys[event.key.keysym.sym]=0;
			break;
				
		case SDL_MOUSEBUTTONUP:
			{
				if (event.button.button==SDL_BUTTON_LEFT) Bouton[0]=0;
				if (event.button.button==SDL_BUTTON_RIGHT) Bouton[1]=0;
				if (event.button.button==SDL_BUTTON_WHEELUP) WHEEL=-1;
				if (event.button.button==SDL_BUTTON_WHEELDOWN) WHEEL=1;
			}
			break;

		case SDL_MOUSEBUTTONDOWN:
			{
				if (event.button.button==SDL_BUTTON_LEFT) Bouton[0]=1;
				if (event.button.button==SDL_BUTTON_RIGHT) Bouton[1]=1;
			}
			break;
		
		case SDL_MOUSEMOTION:

			xMouse=event.motion.x;
			yMouse=event.motion.y;
			break;
		};

	}


	if ((ayM!=yMouse)&&(W))
	{
		if (ayM>yMouse) WHEEL=-1;
		else WHEEL=1;
	}


	axM=xMouse;
	ayM=yMouse;

	return res;

}

#endif
