//////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DUREE1 50
#define DUREE2 200
#define DUREE3 230
#define RAYON_PART 0.1f
#define SCALING_DE_BASE 0.625f
//////////////////////////////////////////////////////////////////////////////////////////////////////////
enum
{
	PTAG_GRAVITY	=	0,
	PTAG_UPGRAVITY	=	1,
	PTAG_UPGRAVITY2	=	2,
	PTAG_STATIC		=	3,
	PTAG_GRASS		=	4,
	PTAG_CLOUDS		=	5
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////
class particule
{
public:
	float r,g,b;
	float r2,g2,b2;
	float r1,g1,b1;
	CVector p,v;
	float ra,rr;
	float duree;
	int t1,t2;
	int texture;
	int tag;
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////
class particules
{
public:

	int NBRE_MAX_PARTICULES;
	int np;
	particule *ps;
	C3DAPI *Render;
	int texture;
	float seuil_y;
	CVector pmin,pmax;
	CVertexBuffer *vb;
	particule tmp;
	CVertexBuffer *effect;
	CVertexBuffer *effect2;
	int grass;	
	unsigned char tag_bounding;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	particules() { tag_bounding=0; grass=0;np=0;seuil_y=-100;NBRE_MAX_PARTICULES=128;ps=new particule[NBRE_MAX_PARTICULES]; vb=NULL; }
	particules(int nbmax) { tag_bounding=0; grass=0;np=0;seuil_y=-100;NBRE_MAX_PARTICULES=nbmax;ps=new particule[NBRE_MAX_PARTICULES]; vb=NULL; }
	~particules() { delete [] ps; killVB(); }

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void setEffect(CVertexBuffer *effecttmp)
	{
		effect=effecttmp;
		effect->resetAssignation();
		effect->setTextureAssociation("tex",TEXTURE_FROM_NT);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void setEffectHalf(CVertexBuffer *effecttmp)
	{
		effect2=effecttmp;
		effect2->resetAssignation();
		effect2->setTextureAssociation("tex",TEXTURE_FROM_NT);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void setVBoptim()
	{
		int n;
		int n1,n2;
		int tex,ptag;
		int start;
		CIndicesSE se;
		float R;

		if (np>0)
		{
			vb=new CVertexBuffer;
			vb->SetAPI(Render);
			vb->SetType(API3D_VERTEXDATAS|API3D_COLORDATAS4|API3D_TEXCOODATAS|API3D_TEXCOODATAS2);
			vb->Init(np*4,np*6);
			vb->LockIndices();
			vb->LockVertices();
			vb->Grouped=true;

			for (n1=0;n1<np;n1++)
			{
				for (n2=n1+1;n2<np;n2++)
				{
					int t1,t2;

					if (ps[n1].tag==PTAG_GRASS) t1=ps[n1].texture;
					else t1=65536 + ps[n1].texture;
					
					if (ps[n2].tag==PTAG_GRASS) t2=ps[n2].texture;
					else t2=65536 + ps[n2].texture;			

					if (t1<t2)
					{
						tmp=ps[n1];
						ps[n1]=ps[n2];
						ps[n2]=tmp;
					}
				}
			}

			start=0;
			tex=ps[0].texture;
			if (ps[0].tag==PTAG_GRASS) ptag=1; else ptag=0;
			if (ps[0].tag==PTAG_CLOUDS) ptag=2;

			for (n=0;n<np;n++)
			{
				int tmptag=0;
				if (ps[n].tag==PTAG_GRASS) {tmptag=1; grass=1;}
				if (ps[n].tag==PTAG_CLOUDS) {tmptag=2;}

				R=ps[n].ra;

				if ((ps[n].texture!=tex)||(ptag!=tmptag))
				{
					se.nSV=0;
					se.nL=0;
					se.nLV=0;
					se.nT2=0;
					se.nT=tex;
					if (ptag==1) se.ref=1; else se.ref=2;
					se.ref=1;
					se.iStart=start*2*3;
					se.iEnd=n*2*3;
					se.vStart=start*4;
					se.vEnd=n*4;
					se.tag=0;
					vb->ListeSE.Add(se);
					start=n;
					ptag=tmptag;
					tex=ps[n].texture;
				}

				vb->SetVertex(n*4 + 0, ps[n].p);
				vb->SetVertex(n*4 + 1, ps[n].p);
				vb->SetVertex(n*4 + 2, ps[n].p);
				vb->SetVertex(n*4 + 3, ps[n].p);

				if (tmptag==2)
				{
					vb->SetTexCoo(n*4 + 0, -1, -1);
					vb->SetTexCoo(n*4 + 1,  1, -1);
					vb->SetTexCoo(n*4 + 2,  1, 1);
					vb->SetTexCoo(n*4 + 3, -1, 1);

					vb->SetTexCoo2(n*4 + 0,  (2*R)/3, -2*R);
					vb->SetTexCoo2(n*4 + 1,  (2*R)/3, -2*R);
					vb->SetTexCoo2(n*4 + 2,  (2*R)/3, 0);
					vb->SetTexCoo2(n*4 + 3,  (2*R)/3, 0);
				}
				else
				if (tmptag==1)
				{
					vb->SetTexCoo(n*4 + 0, -1, -1);
					vb->SetTexCoo(n*4 + 1,  1, -1);
					vb->SetTexCoo(n*4 + 2,  1, 1);
					vb->SetTexCoo(n*4 + 3, -1, 1);

					vb->SetTexCoo2(n*4 + 0,  R/2, -2*R);
					vb->SetTexCoo2(n*4 + 1,  R/2, -2*R);
					vb->SetTexCoo2(n*4 + 2,  R/2, 0);
					vb->SetTexCoo2(n*4 + 3,  R/2, 0);
				}
				else
				{
					vb->SetTexCoo(n*4 + 0, -1, -1);
					vb->SetTexCoo(n*4 + 1,  1, -1);
					vb->SetTexCoo(n*4 + 2,  1,  1);
					vb->SetTexCoo(n*4 + 3, -1,  1);

					vb->SetTexCoo2(n*4 + 0,  R, R);
					vb->SetTexCoo2(n*4 + 1,  R, R);
					vb->SetTexCoo2(n*4 + 2,  R, R);
					vb->SetTexCoo2(n*4 + 3,  R, R);
				}

				if (tmptag==0)
				{
					vb->SetColor(n*4 + 0, ps[n].r,ps[n].g,ps[n].b,0.3f);
					vb->SetColor(n*4 + 1, ps[n].r,ps[n].g,ps[n].b,0.3f);
					vb->SetColor(n*4 + 2, ps[n].r,ps[n].g,ps[n].b,0.3f);
					vb->SetColor(n*4 + 3, ps[n].r,ps[n].g,ps[n].b,0.3f);
					vb->SetIndices(n*2 + 0, n*4 + 0,n*4 + 1,n*4 + 2);
					vb->SetIndices(n*2 + 1, n*4 + 0,n*4 + 2,n*4 + 3);
				}
				else
				{
					vb->SetColor(n*4 + 0, ps[n].r,ps[n].g,ps[n].b,1.0f);
					vb->SetColor(n*4 + 1, ps[n].r,ps[n].g,ps[n].b,1.0f);
					vb->SetColor(n*4 + 2, ps[n].r,ps[n].g,ps[n].b,1.0f);
					vb->SetColor(n*4 + 3, ps[n].r,ps[n].g,ps[n].b,1.0f);
					vb->SetIndices(n*2 + 0, n*4 + 0,n*4 + 2,n*4 + 1);
					vb->SetIndices(n*2 + 1, n*4 + 0,n*4 + 3,n*4 + 2);
				}
			}

			se.nSV=0;
			se.nL=0;
			se.nLV=0;
			se.nT2=0;
			se.nT=tex;
			if (ptag==1) se.ref=1; else se.ref=2;
			se.ref=1;
			se.iStart=start*2*3;
			se.iEnd=np*2*3;
			se.vStart=start*4;
			se.vEnd=np*4;
			se.tag=0;
			vb->ListeSE.Add(se);

			vb->UnlockIndices();
			vb->UnlockVertices();
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void killVB()
	{
		if (vb)
		{
			vb->Release();
			delete vb;
			vb=NULL;
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void clean()
	{
		np=0;
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void add(float x,float y,float z,float r,float g,float b)
	{
		int n;
		float vx,vy,vz;
		float K=0.01f;

		vx=((float) ((rand()%100)-50))/15.0f;
		vy=((float) (-(rand()%50)))/8.0f;
		vz=((float) ((rand()%100)-50))/15.0f;

		for (n=0;n<4;n++)
		{
			if (np<NBRE_MAX_PARTICULES)
			{
				ps[np].tag=PTAG_GRAVITY;
				ps[np].p.Init(x+n*K*vx,y+n*K*vy,z+n*K*vz);
				ps[np].r=r;
				ps[np].g=g;
				ps[np].b=b;
				ps[np].duree=DUREE1;
				ps[np].rr=1;
				ps[np].ra=ps[np].rr;
				ps[np].v.Init(vx,vy,vz);
				ps[np].t1=rand()&1;
				ps[np].t2=rand()&1;

				ps[np].r1=0.9f;
				ps[np].g1=0.9f;
				ps[np].b1=0.9f;

				ps[np].r2=0.9f;
				ps[np].g2=0.9f;
				ps[np].b2=0.9f;
				ps[np].texture=texture;
				np++;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void addGrass(float x,float y,float z,float r,float g,float b,int nt)
	{
		if (np<NBRE_MAX_PARTICULES)
		{
			ps[np].tag=PTAG_GRASS;
			ps[np].p.Init(x,y,z);
			ps[np].r=r;
			ps[np].g=g;
			ps[np].b=b;
			ps[np].rr=1.3f;
			ps[np].ra=ps[np].rr;
			ps[np].v.Init(0,0,0);
			ps[np].t1=0;
			ps[np].t2=0;

			ps[np].r1=1.0f;
			ps[np].g1=1.0f;
			ps[np].b1=1.0f;

			ps[np].r2=1.0f;
			ps[np].g2=1.0f;
			ps[np].b2=1.0f;
			ps[np].texture=nt;

			np++;
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void addClouds(float x,float y,float z,float r,float g,float b,float R,int nt)
	{
		if (np<NBRE_MAX_PARTICULES)
		{
			ps[np].tag=PTAG_CLOUDS;
			ps[np].p.Init(x,y,z);
			ps[np].r=r;
			ps[np].g=g;
			ps[np].b=b;
			ps[np].rr=R;
			ps[np].ra=ps[np].rr;
			ps[np].v.Init(0,0,0);
			ps[np].t1=0;
			ps[np].t2=0;

			ps[np].r1=1.0f;
			ps[np].g1=1.0f;
			ps[np].b1=1.0f;

			ps[np].r2=1.0f;
			ps[np].g2=1.0f;
			ps[np].b2=1.0f;
			ps[np].texture=nt;

			np++;
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void addfixed(float x,float y,float z,float r,float g,float b,float R,int nt)
	{
		if (np<NBRE_MAX_PARTICULES)
		{
			ps[np].tag=PTAG_STATIC;
			ps[np].p.Init(x,y,z);
			ps[np].r=r;
			ps[np].g=g;
			ps[np].b=b;
			ps[np].duree=DUREE2;
			ps[np].rr=R;
			ps[np].ra=R;
			ps[np].v.Init(0,0,0);
			ps[np].t1=1;
			ps[np].t2=1;

			ps[np].r1=r;
			ps[np].g1=g;
			ps[np].b1=b;

			ps[np].r2=r;
			ps[np].g2=g;
			ps[np].b2=b;
			ps[np].texture=nt;
			np++;
		}
		else
		{
			int n;
			int res=-1;
			float min=10000;
			for (n=0;n<np;n++) { if (ps[n].duree<min) { res=n;min=ps[n].duree; }}
			
			if (res>=0)
			{
				ps[res].tag=PTAG_STATIC;
				ps[res].p.Init(x,y,z);
				ps[res].r=r;
				ps[res].g=g;
				ps[res].b=b;
				ps[res].duree=DUREE2;
				ps[res].rr=R;
				ps[res].ra=R;
				ps[res].v.Init(0,0,0);
				ps[res].t1=1;
				ps[res].t2=1;

				ps[res].r1=r;
				ps[res].g1=g;
				ps[res].b1=b;

				ps[res].r2=r;
				ps[res].g2=g;
				ps[res].b2=b;
				ps[res].texture=nt;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void addfire(float x,float y,float z,float r,float g,float b,int nt)
	{
		if (np<NBRE_MAX_PARTICULES)
		{
			ps[np].tag=PTAG_UPGRAVITY;
			ps[np].p.Init(x,y,z);
			ps[np].r=0;
			ps[np].g=0;
			ps[np].b=0;
			ps[np].duree=DUREE2;
			ps[np].rr=4;
			ps[np].ra=4;
			ps[np].v.Init(0,0,0);
			ps[np].t1=1;
			ps[np].t2=1;

			ps[np].r1=r;
			ps[np].g1=g;
			ps[np].b1=b;

			ps[np].r2=r*0.4f;
			ps[np].g2=g*0.1f;
			ps[np].b2=b*0.05f;
			ps[np].texture=nt;
			np++;
		}
		else
		{
			int n;
			int res=-1;
			float min=10000;
			for (n=0;n<np;n++) { if (ps[n].duree<min) { res=n;min=ps[n].duree; }}
			
			if (res>=0)
			{
				ps[res].tag=PTAG_UPGRAVITY;
				ps[res].p.Init(x,y,z);
				ps[res].r=0;
				ps[res].g=0;
				ps[res].b=0;
				ps[res].duree=DUREE2;
				ps[res].rr=4;
				ps[res].ra=4;
				ps[res].v.Init(0,0,0);
				ps[res].t1=1;
				ps[res].t2=1;

				ps[res].r1=r;
				ps[res].g1=g;
				ps[res].b1=b;

				ps[res].r2=r*0.4f;
				ps[res].g2=g*0.1f;
				ps[res].b2=b*0.05f;
				ps[res].texture=nt;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void addfire2(float x,float y,float z,float r,float g,float b,int nt)
	{
		if (np<NBRE_MAX_PARTICULES)
		{
			ps[np].tag=PTAG_UPGRAVITY2;
			ps[np].p.Init(x,y,z);
			ps[np].r=0;
			ps[np].g=0;
			ps[np].b=0;
			ps[np].duree=DUREE3;
			ps[np].rr=20;
			ps[np].ra=20;
			ps[np].v.Init(0,0,0);
			ps[np].t1=1;
			ps[np].t2=1;

			ps[np].r1=r;
			ps[np].g1=g;
			ps[np].b1=b;

			ps[np].r2=r*0.4f;
			ps[np].g2=g*0.1f;
			ps[np].b2=b*0.05f;

			ps[np].texture=nt;
			np++;
		}
		else
		{
			int n;
			int res=-1;
			float min=10000;
			for (n=0;n<np;n++) { if (ps[n].duree<min) { res=n;min=ps[n].duree; }}

			if (res>=0)
			{
				ps[res].tag=PTAG_UPGRAVITY2;
				ps[res].p.Init(x,y,z);
				ps[res].r=0;
				ps[res].g=0;
				ps[res].b=0;
				ps[res].duree=DUREE3;
				ps[res].rr=20;
				ps[res].ra=20;
				ps[res].v.Init(0,0,0);
				ps[res].t1=1;
				ps[res].t2=1;

				ps[res].r1=r;
				ps[res].g1=g;
				ps[res].b1=b;

				ps[res].r2=r*0.4f;
				ps[res].g2=g*0.1f;
				ps[res].b2=b*0.05f;

				ps[res].texture=nt;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void anim(float DT)
	{
		int n;
		float dt=0.035f*DT;
		float t;
		
		n=0;
		while (n<np) 
		{
			if (ps[n].tag!=PTAG_STATIC)
			{
				if (ps[n].tag==PTAG_GRAVITY) 
				{
					ps[n].v.y+=9.81f*dt;
					t=1.0f-ps[n].duree/DUREE1;
				}
				if (ps[n].tag==PTAG_UPGRAVITY) 
				{
					ps[n].v.y-=0.1f*dt;
					t=1.0f-ps[n].duree/DUREE2;
				}
				
				if (ps[n].tag==PTAG_UPGRAVITY2)
				{
					ps[n].v.y-=0.1f*dt;
					t=1.0f-ps[n].duree/DUREE3;
				}

				ps[n].p+=ps[n].v*dt;
				
				ps[n].r=ps[n].r1 + t*(ps[n].r2 - ps[n].r1);
				ps[n].g=ps[n].g1 + t*(ps[n].g2 - ps[n].g1);
				ps[n].b=ps[n].b1 + t*(ps[n].b2 - ps[n].b1);

				ps[n].ra=0.25f*ps[n].rr*(1-t);
				
				ps[n].duree-=DT;				

				if ((ps[n].duree<=0)||(ps[n].p.y<seuil_y))
				{
					if (np>0)
					{
						np--;
						ps[n]=ps[np];
					}
				}
				else n++;
			}
			else n++;
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void draw_halftone(float sx,float sy)
	{
		int n;
		CVector4 vec,vec2;
		CMatrix M1,M2,M;
		float x,y,d;
		float c=0.9f;
		int pos=0;

		if (np==0) return;

		if (vb)
		{
			Render->SetParams(API3D_ALPHAMULTIGROUP,DRAW);
			CVector base_1,base_2;
			CVector view;
			int NT=Render->Decal_nt;
			Render->Decal_nt=0;

			M.Inverse4x4(Render->VIEW);	
			view.Init(M.a[2][0],M.a[2][1],M.a[2][2]);
			view.neg();
			view.Normalise();
			base_1.Base(view,1);
			base_2.Base(view,0);

			Render->SetParams(API3D_ZBUFFER,ON);
			if (grass)
			{
				Render->SetParams(API3D_ALPHATEST,ENABLE);
				Render->SetParams(API3D_ALPHATEST,128);
				Render->SetParams(API3D_ALPHATEST,GREATER);
			}
			else
			{
				Render->SetParams(API3D_ALPHATEST,ENABLE);
				Render->SetParams(API3D_ALPHATEST,8);
				Render->SetParams(API3D_ALPHATEST,GREATER);
				Render->SetParams(API3D_ZBUFFER,WRITEOFF);
			}

			Render->SetEffect(effect2);
			effect2->setVector("tangent",base_1);
			effect2->setVector("binormal",base_2);
			effect2->setMatrixWorld("WORLD");
			effect2->setMatrixViewProj("VIEWPROJ");
			effect2->setFloat("scale",SCALING_DE_BASE);
			Render->SetVertexBuffer(vb);
			Render->DrawVertexBuffer();
			Render->SetEffect(NULL);

			Render->SetParams(API3D_ALPHATEST,DISABLE);
			Render->SetParams(API3D_ZBUFFER,WRITEOFF);

			Render->Decal_nt=NT;
		}
		else
		{
			Render->SetParams(API3D_ALPHATEST,ENABLE);
			Render->SetParams(API3D_ALPHATEST,8);
			Render->SetParams(API3D_ALPHATEST,GREATER);

			pmin.Init(10000,10000,10000);
			pmax.Init(-10000,-10000,-10000);
			M1=Render->WORLD * Render->VIEW;
			M2=Render->PROJ * Render->VIEWPORT;
			M=M1*M2;
			for (n=0;n<np;n++)
			{
				if (ps[n].tag==PTAG_GRAVITY) Render->SetParams(API3D_BLEND,ON);
				else Render->SetParams(API3D_BLEND,BLEND_GOURAUD);
				Render->SetTexture(ps[n].texture);
				vec2.Init(ps[n].p);
				if (ps[n].p.x<pmin.x) pmin.x=ps[n].p.x;
				if (ps[n].p.y<pmin.y) pmin.y=ps[n].p.y;
				if (ps[n].p.z<pmin.z) pmin.z=ps[n].p.z;
				if (ps[n].p.x>pmax.x) pmax.x=ps[n].p.x;
				if (ps[n].p.y>pmax.y) pmax.y=ps[n].p.y;
				if (ps[n].p.z>pmax.z) pmax.z=ps[n].p.z;
				VECTOR4MATRIX(vec,vec2,M);			
				x=vec.x;
				y=vec.y;
				vec.Init(ps[n].p);
				VECTOR4MATRIX(vec2,vec,M1);

				if (vec2.z>Render->Front)
				{
					d=(sx/1024)*ps[n].ra*Render->Distance/vec2.z;
					vec2.z-=0.25f;
					VECTOR4MATRIX(vec,vec2,M2);
					Render->QuadZ(vec.z,vec.w,(float) (x-d),(float) (y-d),(float) (d*2),(float) (d*2),(float) (1-ps[n].t1),(float) (1-ps[n].t2),(float) (ps[n].t1),(float) (ps[n].t2),ps[n].r*0.5f,ps[n].g*0.5f,ps[n].b*0.5f,0.3f);
				}
			}
		}

		Render->Flush();

		Render->SetParams(API3D_ALPHATEST,DISABLE);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
	void draw(float sx,float sy)
	{
		int n;
		CVector4 vec,vec2;
		CMatrix M1,M2,M;
		float x,y,d;
		float c=0.9f;
		int pos=0;

		if (np==0) return;
		
		if (vb)
		{
			Render->SetParams(API3D_ALPHAMULTIGROUP,DRAW);

			CVector base_1,base_2;
			CVector view;
			int NT=Render->Decal_nt;
			Render->Decal_nt=0;

			
			if (grass)
			{
				Render->SetParams(API3D_ALPHATEST,ENABLE);
				Render->SetParams(API3D_ALPHATEST,128);
				Render->SetParams(API3D_ALPHATEST,GREATER);
			}
			else
			{
				Render->SetParams(API3D_ALPHATEST,ENABLE);
				Render->SetParams(API3D_ALPHATEST,0);
				Render->SetParams(API3D_ALPHATEST,GREATER);
			}

			M.Inverse4x4(Render->VIEW);	
			view.Init(M.a[2][0],M.a[2][1],M.a[2][2]);
			view.neg();
			view.Normalise();
			base_1.Base(view,1);
			base_2.Base(view,0);
			Render->SetEffect(effect);
			effect->setVector("tangent",base_1);
			effect->setVector("binormal",base_2);
			effect->setMatrixWorld("WORLD");
			effect->setMatrixViewProj("VIEWPROJ");
			effect->setFloat("scale",SCALING_DE_BASE);
			Render->SetVertexBuffer(vb);
			Render->DrawVertexBuffer();
			Render->SetEffect(NULL);

			Render->SetParams(API3D_ALPHATEST,DISABLE);
			Render->SetParams(API3D_ZBUFFER,WRITEOFF);
			Render->Decal_nt=NT;
		}
		else
		{
			VECTORINIT(pmin,10000,10000,10000);
			VECTORINIT(pmax,-10000,-10000,-10000);
			MATRIXMATRIX(M1,Render->WORLD,Render->VIEW);
			MATRIXMATRIX(M2,Render->PROJ,Render->VIEWPORT);
			MATRIXMATRIX(M,M1,M2);

			Render->SetParams(API3D_ALPHATEST,ENABLE);
			Render->SetParams(API3D_ALPHATEST,8);
			Render->SetParams(API3D_ALPHATEST,GREATER);

			if ((ps[0].tag==PTAG_GRAVITY)||(ps[0].tag==PTAG_GRASS)) 
			{
				float value=(sx/1024)*Render->Distance;
				Render->SetParams(API3D_BLEND,ON);

				for (n=0;n<np;n++)
				{
					Render->SetTexture(ps[n].texture);
					VECTOR4INIT(vec2,ps[n].p);					
					if (tag_bounding)
					{
						if (ps[n].p.x<pmin.x) pmin.x=ps[n].p.x;
						if (ps[n].p.y<pmin.y) pmin.y=ps[n].p.y;
						if (ps[n].p.z<pmin.z) pmin.z=ps[n].p.z;
						if (ps[n].p.x>pmax.x) pmax.x=ps[n].p.x;
						if (ps[n].p.y>pmax.y) pmax.y=ps[n].p.y;
						if (ps[n].p.z>pmax.z) pmax.z=ps[n].p.z;
					}
					VECTOR4MATRIX(vec,vec2,M);			
					x=vec.x;
					y=vec.y;
					VECTOR4INIT(vec,ps[n].p);
					VECTOR4MATRIX(vec2,vec,M1);
					if (vec2.z>Render->Front)
					{
						d=(ps[n].ra*value)/vec2.z;
						vec2.z-=0.25f;
						VECTOR4MATRIX(vec,vec2,M2);
						if (ps[n].tag==PTAG_GRASS) Render->QuadZ(vec.z,vec.w,(float) (x-d/2),(float) (y-d*2),(float) d,(float) (d*2),0,0,1,1,ps[n].r,ps[n].g,ps[n].b);
						else Render->QuadZ(vec.z,vec.w,(float) (x-d),(float) (y-d),(float) (d*2),(float) (d*2),(float) (1-ps[n].t1),(float) (1-ps[n].t2),(float) (ps[n].t1),(float) (ps[n].t2),ps[n].r,ps[n].g,ps[n].b,0.3f);
					}
				}
			}
			else 
			{
				float value=(sx/1024)*Render->Distance;
				Render->SetParams(API3D_BLEND,BLEND_GOURAUD);
				Render->SetTexture(ps[0].texture);

				for (n=0;n<np;n++)
				{
					VECTOR4INIT(vec2,ps[n].p);
					if (tag_bounding)
					{
						if (ps[n].p.x<pmin.x) pmin.x=ps[n].p.x;
						if (ps[n].p.y<pmin.y) pmin.y=ps[n].p.y;
						if (ps[n].p.z<pmin.z) pmin.z=ps[n].p.z;
						if (ps[n].p.x>pmax.x) pmax.x=ps[n].p.x;
						if (ps[n].p.y>pmax.y) pmax.y=ps[n].p.y;
						if (ps[n].p.z>pmax.z) pmax.z=ps[n].p.z;
					}
					VECTOR4MATRIX(vec,vec2,M);			
					x=vec.x; y=vec.y;
					VECTOR4INIT(vec,ps[n].p);
					VECTOR4MATRIX(vec2,vec,M1);
					if (vec2.z>Render->Front)
					{
						d=(ps[n].ra*value)/vec2.z;
						vec2.z-=0.25f;
						VECTOR4MATRIX(vec,vec2,M2);						
						Render->QuadZ(vec.z,vec.w,(float) (x-d),(float) (y-d),(float) (d*2),(float) (d*2),(float) (1-ps[n].t1),(float) (1-ps[n].t2),(float) (ps[n].t1),(float) (ps[n].t2),ps[n].r,ps[n].g,ps[n].b,0.3f);
					}
				}

			}

		}

		Render->Flush();

		Render->SetParams(API3D_ALPHATEST,DISABLE);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////
