/////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	CHEVROLET v1.1
//  (c) Laurent Canc Francis 08/10/2012
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////
float scalex=1.0f;
float scaley=1.0f;
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma warning(disable:4244)
#pragma warning(disable:4309)
#pragma warning(disable:4101)
#pragma warning(disable:4018)

#ifdef WIN32
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include "cpp\games.h"
#include "..\lib3d\base\params.h"
#include "..\lib3d\base\maths.h"
#include "..\lib3d\base\objects3D.h"
#include "..\lib3d\base\3d_api.h"
#include "..\lib3d\misc\metaballs.h"
#include "..\lib3d\data\png.h"
extern float PNG_valueofbeefsteack;
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../ned/classned.h"
#include "../ned/jpeg2000/jpeg2000.h"
#else
#include "cpp/games.h"
#include "../lib3d/base/params.h"
#include "../lib3d/base/maths.h"
#include "../lib3d/base/objects3D.h"
#include "../lib3d/base/3d_api.h"
#include "../lib3d/misc/metaballs.h"
#include "../lib3d/data/png.h"
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../ned/classned.h"
#include "../ned/jpeg2000/jpeg2000.h"
#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef WIN32
#include <unistd.h>

void Sleep(int ms)
{
	usleep(ms*1000);
}

#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef WIN32
#include <math.h>
#include <stdio.h>
#include <direct.h>
#include <shlobj.h>
#else
#include <math.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../sound/api_sound.h"
//////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../sound/api_sound.h"
#include "../sound/modplayer_sdl_directx.h"
//////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////
void GAMES_ACTIVATE_PROC(bool fm,bool fa)
{
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool fexist(char * str)
{
	FILE * f;

	f=fopen(str,"rb");
	if (f==NULL)
	{
		// le fichier n'existe pas
		return false;
	}
	else
	{
		fclose(f);
		return true;
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
char			temp_str[1024];
//////////////////////////////////////////////////////////////////////////////////////////////////////
char * getExt(char *name)
{
	int n;
	n=strlen(name)-1;
	while ((n>=0)&&(name[n]!='.')) n--;
	n++;
	sprintf(temp_str,"%s",&name[n]);

	for (n=0;n<(int)strlen(temp_str);n++)
	{
		if ((temp_str[n]>='a')&&(temp_str[n]<='z')) temp_str[n]+='A'-'a';
	}
	return temp_str;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void setExt(char *name,char *ext)
{
	int n;
	n=strlen(name)-1;
	while ((n>=0)&&(name[n]!='.')) n--;
	n++;
	name[n++]=ext[0];
	name[n++]=ext[1];
	name[n++]=ext[2];
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void READ_IMAGESTRICT(char *name,struct IMAGE_DATAS *im,int ALPHASETTINGS)
{
	if (strcmp(getExt(name),"PNG")==0) READ_PNG(name,im,ALPHASETTINGS);
	if (strcmp(getExt(name),"JP2")==0) READ_JPEG2000(name,im,ALPHASETTINGS);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool READ_IMAGE(char *cname,struct IMAGE_DATAS *im,int ALPHASETTINGS)
{
	bool res=true;
	char sname[512];
	char name[512];
	int n;

	sprintf(name,"%s",cname);

	n=strlen(name)-1;
	while ((n>0)&&(name[n]!='.')) n--;
	if (n>0) name[n]='\0';

	sprintf(sname,"%s.png",name);
	if (fexist(sname)) READ_PNG(sname,im,ALPHASETTINGS);
	else
	{
		sprintf(sname,"%s.jp2",name);
		if (fexist(sname)) READ_JPEG2000(sname,im,ALPHASETTINGS);
		else
		{
			sprintf(sname,"%s.j2k",name);
			if (fexist(sname)) READ_JPEG2000(sname,im,ALPHASETTINGS);
			else res=false;
		}
	}

	return res;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void READ_IMG(char *cname,struct IMAGE_DATAS *im,int ALPHASETTINGS)
{
	READ_IMAGE(cname,im,ALPHASETTINGS);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
C3DAPI Render;
NED Scene;
CMatrix MView;
//////////////////////////////////////////////////////////////////////////////////////////////////////

void Initialise()
{
	Init_WorldUp(0,-1,0);

	Scene.SetMode(0);
	Scene.NEDRender=(&Render);
	Scene.SelectedWO=-1;
	Scene.AncienWO=-1;
	Scene.InitLightmaps();

	Scene.SetParams(NED_GENERATE_FAKE_BUMPLIGHTED_TEXTURE);
	if (Render.CheckDevice(DEV_MULTITEXTURE)) Scene.SetParams(NED_DO_NOT_CALCULATE_TREE_SHADOWS_IN_LIGHTMAP);

	Render.SetParams(API3D_BUMP_SETTEXTURE,VALUE_FINDING_BUMP_MAP);
	Render.SetParams(API3D_BUMP_DISPLACE_SETTEXTURE,VALUE_FINDING_BUMP_MAP_DISPLACE);
	Render.SetParams(API3D_HORIZON_MAPS_SETTEXTURE,VALUE_FINDING_HORIZON_MAP);


	Scene.ResetWorldObjectsAndTextures();
	Scene.SelectedWO=-1;
	Scene.AncienWO=-1;
	Scene.InitLightmaps();

	Scene.OMBREDANSLIGHTMAP=false;
	Scene.SetParams(NED_ALTERNATIVE_SHADOWMAPS);
	Scene.SetParams(NED_DYNAMICLIGHTING_VERSION2);

	int n1,n2;
	int x,y;
	char ptr[256*256*4];
	CVector u;

	memset(ptr,255,32*32*4);
	Render.CreateTexture(1024,32,32,ptr,32,32,NO_ALPHA);

	memset(ptr,255,128*128*4);
	Render.SetParams(API3D_CREATETEXTURE,MIPMAP);
	Render.CreateTexture(1023,32,ptr,32,NO_ALPHA);
	for (n1=0;n1<128;n1++)
		for (n2=0;n2<128;n2++)
		{
			x=n1-64.0f;
			y=n2-64.0f;
			x=sqrtf(x*x+y*y)/64.0f;
			if (x>1) x=1;
			x=1-x;
			ptr[4*(n1+n2*128) + 0]=(int) (x*255);
			ptr[4*(n1+n2*128) + 1]=(int) (x*255);
			ptr[4*(n1+n2*128) + 2]=(int) (x*255);
			ptr[4*(n1+n2*128) + 3]=(int) ((x*x)*255);
		}
	Render.CreateTexture(1022,128,ptr,128,ALPHA);

	Render.SetParams(API3D_CREATETEXTURE,CLAMP);

	for (n1=0;n1<256;n1++)
		for (n2=0;n2<256;n2++)
		{
			x=n1-128;
			y=n2-128;
			x=sqrtf(x*x+y*y)/128.0f;
			x=1-x;
			if (x>1) x=1;
			if (x<0) x=0;
			ptr[4*(n1+n2*256) + 0]=(int) (x*255);
			ptr[4*(n1+n2*256) + 1]=(int) (x*255);
			ptr[4*(n1+n2*256) + 2]=(int) (x*255);
			ptr[4*(n1+n2*256) + 3]=(char) 255;
		}

	Render.CreateTexture(998,256,ptr,256,NO_ALPHA);

	for (n1=0;n1<256;n1++)
		for (n2=0;n2<256;n2++)
		{
			u.x=128-n1;
			u.y=128-n2;
			u.z=128;
			u.Normalise();
			ptr[4*(n1+n2*256) + 0]=(int) ((128 + 127*u.x));
			ptr[4*(n1+n2*256) + 1]=(int) ((128 + 127*u.y));
			ptr[4*(n1+n2*256) + 2]=(int) ((128 + 127*u.z));
			ptr[4*(n1+n2*256) + 3]=(char) 255;
		}

	Render.CreateTexture(999,256,ptr,256,NO_ALPHA);
    
    memset(ptr,255,256*256*4);
	Render.CreateTexture(4,256,ptr,256,NO_ALPHA);


	Render.SetParams(API3D_CREATETEXTURE,REPEAT);

	/////////////////////////////////////////////////////////////////////


	Scene.fonction_progress_load=NULL;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
#define BORD 80
//////////////////////////////////////////////////////////////////////////////////////////////////////
void BordsNoirs()
{
    int w=Render.SCREEN_X;
    int h=Render.SCREEN_Y;

    Render.SetTexture(1200);
    Render.SetParams(API3D_BLEND,OFF);
    Render.SetParams(API3D_ZBUFFER,OFF);
    Render.Quad(0,0,w,BORD,0,0,1,1,0,0,0);
    Render.Quad(0,h-BORD,w,BORD,0,0,1,1,0,0,0);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
void InitGlow()
{
	Render.Decal_nt=0;
	Render.SetParams(API3D_RENDERTARGET,SECONDARY2);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_ZBUFFER,ON);
	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_SECONDARYSURFACE,SCALE);
	Render.SetProjection();
	Render.LoadViewMatrix(MView);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void GlowRender(int LEVEL_HIGHLIGHT,float K,float aspect)
{
	int n;
	float f;
	
	Render.SetParams(API3D_TEXTURING,OFF);
	
	Render.SetParams(API3D_RENDERTARGET,SECONDARY1);
	Render.SetParams(API3D_SECONDARYSURFACE,NO_SCALE);
	Render.SetParams(API3D_ZBUFFER,ON);
	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetParams(API3D_ZBUFFER,OFF);
	for (n=0;n<LEVEL_HIGHLIGHT;n++)
	{
		float f=0.35f*(1-((float) n)/LEVEL_HIGHLIGHT)*(0.15f*LEVEL_HIGHLIGHT/3);
		Render.Blur(0,0,Render.GetWidth(),Render.GetHeight(),K*(1+n)/LEVEL_HIGHLIGHT,aspect*f,aspect*f,aspect*f,1);
	}
	
	Render.SetParams(API3D_BLEND,OFF);
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_RENDERTARGET,PRIMARY);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	Render.SetTexture(SECONDARYTEXTURE1);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	Render.SetParams(API3D_BLEND,OFF);
	
	Render.SetParams(API3D_ALPHATEST,DISABLE);
}

void GlowRender(int LEVEL_HIGHLIGHT,float K)
{
	GlowRender(LEVEL_HIGHLIGHT,K,1.0f);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void GlowRendeval2(int LEVEL_HIGHLIGHT,float K,float aspect)
{
	int n;
	float f;
	
	Render.SetParams(API3D_TEXTURING,OFF);
	
	Render.SetParams(API3D_RENDERTARGET,SECONDARY1);
	Render.SetParams(API3D_SECONDARYSURFACE,NO_SCALE);
	Render.SetParams(API3D_ZBUFFER,ON);
	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetParams(API3D_ZBUFFER,OFF);
	for (n=0;n<LEVEL_HIGHLIGHT;n++)
	{
		float f=0.35f*(1-((float) n)/LEVEL_HIGHLIGHT)*(0.15f*LEVEL_HIGHLIGHT/3);
		Render.Blur(0,0,Render.GetWidth(),Render.GetHeight(),K*(1+n)/LEVEL_HIGHLIGHT,aspect*f,aspect*f,aspect*f,1);
	}
	
	Render.SetParams(API3D_BLEND,OFF);
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_RENDERTARGET,PRIMARY);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	
	
	Render.SetTexture(SECONDARYTEXTURE1);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	Render.SetParams(API3D_BLEND,OFF);
	
	Render.SetParams(API3D_ALPHATEST,DISABLE);
}

void GlowRendeval2(int LEVEL_HIGHLIGHT,float K)
{
	GlowRendeval2(LEVEL_HIGHLIGHT,K,1.0f);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void GlowRenderaa(int LEVEL_HIGHLIGHT,float K,float aspect)
{
	int n;
	float f;
	
	Render.SetParams(API3D_TEXTURING,OFF);
	
	Render.SetParams(API3D_RENDERTARGET,SECONDARY1);
	Render.SetParams(API3D_SECONDARYSURFACE,NO_SCALE);
	Render.SetParams(API3D_ZBUFFER,ON);
	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetParams(API3D_ZBUFFER,OFF);
	for (n=1;n<LEVEL_HIGHLIGHT;n++)
	{
		float f=0.35f*(1-((float) n)/LEVEL_HIGHLIGHT)*(0.15f*LEVEL_HIGHLIGHT/3);
		Render.Blur(0,0,Render.GetWidth(),Render.GetHeight(),K*(1+n)/LEVEL_HIGHLIGHT,aspect*f,aspect*f,aspect*f,1);
	}
	
	Render.SetParams(API3D_BLEND,OFF);
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_RENDERTARGET,PRIMARY);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetTexture(SECONDARYTEXTURE2);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	
	Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
	Render.SetTexture(SECONDARYTEXTURE1);
	Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1, 1.0f,1.0f,1.0f,1);
	Render.SetParams(API3D_BLEND,OFF);
	
	Render.SetParams(API3D_ALPHATEST,DISABLE);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
void vegetaux_set(CVertexBuffer *effect,int nT,int nT2,int tag);
//////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////
float COUNTER_FADE=0.0f;
float INCREMENT_FADE=1.0f;
int fade_start=0;
int fade_end=0;
//////////////////////////////////////////////////////////////////////////////////////////////////////
void InitFade()
{
	char img[64*64*4];
	memset(img,255,64*64*4);
	Render.CreateTexture(1200,64,64,img,64,64,NO_ALPHA);
	COUNTER_FADE=0.0f;
	INCREMENT_FADE=1.0f;
	fade_start=0;
	fade_end=0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////

bool first_fade=true;
void InitFade(int start,int end)
{
	if (first_fade)
	{
		char img[64*64*4];
		memset(img,255,64*64*4);
		Render.CreateTexture(1200,64,64,img,64,64,NO_ALPHA);
	}

	first_fade=false;

	COUNTER_FADE=0.0f;
	INCREMENT_FADE=1.0f;
	fade_start=start;
	fade_end=end;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseFade()
{
	TabKeys[KEY_SPACE]=0;
	Render.FreeAllTextures();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void Fade(float dt)
{
	COUNTER_FADE+=INCREMENT_FADE*dt;
	if (COUNTER_FADE>128) COUNTER_FADE=128;
	Render.SetTexture(1200);
	float f=1.0f - (COUNTER_FADE/128.0f);

	Render.SetParams(API3D_RENDERTARGET,PRIMARY);
	Render.SetParams(API3D_BLEND,ON);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_CULL,CCW);

	Render.SetParams(API3D_TEXTURING,OFF);
	
    Render.SetTexture(1200);

	if (f>1.0f) f=1.0f;
	
	if (COUNTER_FADE<128.0f)
	if (f>0.0f)
	{
		if (INCREMENT_FADE>0)
		{
			if (fade_start==0) Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,0,0,0,f);
			else Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,1,1,f);
		}
		else
		{
			if (fade_end==0) Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,0,0,0,f);
			else Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,1,1,f);
		}
	}

	Render.SetParams(API3D_ZBUFFER,ON);
	Render.SetParams(API3D_BLEND,OFF);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
void InitFade2(int start,int end)
{
	char img[64*64*4];
	memset(img,255,64*64*4);
	Render.CreateTexture(1200,64,64,img,64,64,NO_ALPHA);
	COUNTER_FADE=0.0f;
	INCREMENT_FADE=1.0f;
	fade_start=start;
	fade_end=end;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseFade2()
{
	TabKeys[KEY_SPACE]=0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
void Fade2(float dt)
{
	COUNTER_FADE+=INCREMENT_FADE*dt;
	if (COUNTER_FADE>32) COUNTER_FADE=32;
	Render.SetTexture(1200);
	float f=1.0f - (COUNTER_FADE/32.0f);

	Render.SetParams(API3D_RENDERTARGET,PRIMARY);
	Render.SetParams(API3D_BLEND,ON);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_CULL,CCW);
	if (f>1.0f) f=1.0f;

    Render.SetTexture(1200);
	if (f>0.0f)
	{
		if (INCREMENT_FADE>0)
		{
			if (fade_start==0) Render.Quad(0,BORD,Render.GetWidth(),Render.GetHeight()-2*BORD,0,0,1,1,0,0,0,f);
			else Render.Quad(0,BORD,Render.GetWidth(),Render.GetHeight()-2*BORD,0,0,1,1,1,1,1,f);
		}
		else
		{
			if (fade_end==0) Render.Quad(0,BORD,Render.GetWidth(),Render.GetHeight()-2*BORD,0,0,1,1,0,0,0,f);
			else Render.Quad(0,BORD,Render.GetWidth(),Render.GetHeight()-2*BORD,0,0,1,1,1,1,1,f);
		}
	}

	Render.SetParams(API3D_ZBUFFER,ON);
	Render.SetParams(API3D_BLEND,OFF);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
bool DrawImage(char * filename)
{
	struct IMAGE_DATAS im;

	TimeInit();

	READ_IMG(filename,&im,ALPHA1);
	Render.CreateTexture(450,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);

	int deltat=TimeGet();
	int ms=6200+55*20-deltat*20;
	if (ms<0) ms=0;

	float dt;
	TimeInit();

	int n=0;
	int res=0;
	float fader=0.0f;

	while (fader<1.0f-SMALLF)
	{
		ReadEvents();
        if (TabKeys[KEY_ESCAPE]) return false;
		if (Render.BEGIN())
		{
			Render.ClearVideoAndZBuffer();
			Render.SetParams(API3D_CULL,ON);
			Render.SetParams(API3D_CULL,CCW);
			Render.SetTexture(450);
			if (fader>1.0f) fader=1.0f;
			Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,fader,fader,fader);
			Render.END();
			Render.FlipDoubleBuffer();
			dt=TimeGet();
		}
		fader+=(1.0f/8.0f)*dt;  //40.0f
	}

    Sleep(ms);

	while (fader!=0.0f)
	{
		ReadEvents();
        if (TabKeys[KEY_ESCAPE]) return false;
		if (Render.BEGIN())
		{
			Render.ClearVideoAndZBuffer();
			Render.SetParams(API3D_CULL,ON);
			Render.SetParams(API3D_CULL,CCW);
			Render.SetTexture(450);
			if (fader<0.0f) fader=0.0f;
			Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,fader,fader,fader);
			Render.END();
			Render.FlipDoubleBuffer();
			dt=TimeGet();
		}
		fader-=(1.0f/8.0f)*dt;

		if (fader<0) fader=0.0f;
	}

	if (Render.BEGIN())
	{
		Render.ClearVideoAndZBuffer();
		Render.END();
		Render.FlipDoubleBuffer();
	}

	Render.FreeTexture(450);

	return true;
}


float faderinout=0.0f;
//////////////////////////////////////////////////////////////////////////////////////////////////////
bool DrawImageFadeIn(char * filename)
{
	struct IMAGE_DATAS im;
	READ_IMG(filename,&im,ALPHA1);
	Render.CreateTexture(450,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);

	float dt;
	TimeInit();

	int n=0;
	int res=0;

	faderinout=0.0f;
	
	Render.SetParams(API3D_MULTIQUADS,ON);

	while (faderinout<=1.0f)
	{
		ReadEvents();
        if (TabKeys[KEY_ESCAPE]) return false;
		if (Render.BEGIN())
		{
			Render.ClearVideoAndZBuffer();
			Render.SetParams(API3D_CULL,ON);
			Render.SetParams(API3D_CULL,CCW);
			Render.SetTexture(450);

			int len=1 + faderinout*faderinout*( 512 -1);
			if (faderinout>0.95f) Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,1,1,1);
			else
			{
			for (int x=0;x<len;x++)
				for (int y=0;y<len;y++)
				{
					Render.Quad(((float) x*Render.SCREEN_X)/len,((float) y*Render.SCREEN_Y)/len,(float) Render.SCREEN_X/len,(float) Render.SCREEN_Y/len,(float) x/len + 0.5f/len,(float)y/len + 0.5f/len,(float) x/len + 0.5f/len,(float)y/len + 0.5f/len,faderinout,faderinout,faderinout);
				}
			}
			Render.END();
			Render.FlipDoubleBuffer();
			dt=TimeGet();
		}
		faderinout+=0.025f*dt;
	}

	Render.SetParams(API3D_MULTIQUADS,OFF);

	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.SetTexture(450);
	Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,1,1,1);
	Render.END();
	Render.FlipDoubleBuffer();


	return true;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool DrawImageFadeOut()
{
	float dt;
	TimeInit();
	
	Render.SetParams(API3D_MULTIQUADS,ON);

	faderinout=1.0f;
	while (faderinout>0.0f)
	{
		ReadEvents();
        if (TabKeys[KEY_ESCAPE]) return false;
		if (Render.BEGIN())
		{
			Render.ClearVideoAndZBuffer();
			Render.SetParams(API3D_CULL,ON);
			Render.SetParams(API3D_CULL,CCW);
			Render.SetTexture(450);

			int len=1 + faderinout*faderinout*( 512 -1);
			if (faderinout>0.95f) Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,1,1,1);
			else
			{
			for (int x=0;x<len;x++)
				for (int y=0;y<len;y++)
				{
					Render.Quad(((float) x*Render.SCREEN_X)/len,((float) y*Render.SCREEN_Y)/len,(float) Render.SCREEN_X/len,(float) Render.SCREEN_Y/len,(float) x/len + 0.5f/len,(float)y/len + 0.5f/len,(float) x/len + 0.5f/len,(float)y/len + 0.5f/len,faderinout,faderinout,faderinout);
				}
			}
			Render.END();
			Render.FlipDoubleBuffer();
			dt=TimeGet();
		}
		faderinout-=0.025f*dt;
	}

	Render.SetParams(API3D_MULTIQUADS,OFF);

	Render.ClearVideoAndZBuffer();
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);
	Render.END();
	Render.FlipDoubleBuffer();

	Render.FreeTexture(450);

	return true;
}

extern bool GET_EQUALIZER;
extern bool GLOBAL;
extern int ValueLeft;
extern int ValueRight;


//////////////////////////////////////////////////////////////////////////////////////////////////////
bool Meuf(int EFFECT_DT)
{
	bool res=true;
	
	char * script_envmap_bump =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	MATRIX VIEWPROJLIGHT;\n"
	"	MATRIX VIEWPORTLIGHT;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR LIGHTPOS;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST med=0.5,0.3;\n"
	"	TEXTURE Tex;\n"
	"	TEXTURE Shd;\n"
	"	TEXTURE Env;\n"
	"	TEXTURE Bump;\n"
	"	PSCONST psone=0.2,0.2,0.8,1.0;\n"
	"	PSCONST pdd=0.0025,0.005,0.125,0.0025;\n"
	"	PSCONST psamb=0.15,0.15,0.15,1.0;\n"
	"	CONST scale=0.0009765625,0.5;\n"
	"	CONST cst=0.01,0.1,0.1;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos = iPos *4 WORLD;\n"
	"		tNorm = iNorm *3 WORLD;\n"
	"       ldir = tPos - CAMERA;\n"
	"       ldir = normalise( ldir );\n"
	"       N = tNorm + tNorm + ldir;\n"
	"       N = normalise( N );\n"
	"       ripoux.x = ( tNorm | VECLIGHT );\n"
	"       ldir = tPos - LIGHTPOS;\n"
	"       dist.x = norme( ldir );\n"
	"		oPos = tPos *4 VIEWPROJ;\n"
	"		posi = tPos *4 VIEWPROJLIGHT;\n"
	"		div.w = reciprocal( posi );\n"
	"		posi.x = posi.x * div.w;\n"
	"		posi.y = posi.y * div.w;\n"
	"	[DIFFUSE]\n"
	"		oDiffuse.x = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.y = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.z = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.w = MULTI.x * dist.x - cst.x;\n"
	"	[MAPPING0]\n"
	"		oTexture0.x = iTexture0.x;\n"
	"		oTexture0.y = iTexture0.y;\n"
	"	[MAPPING1]\n"
	"		oTexture1.x = med.x - med.x * N.x;\n"
	"		oTexture1.y = med.x + med.x * N.y;\n"
	"	[MAPPING2]\n"	
	"		oTexture2.x = scale.y + posi.x * scale.y;\n"
#ifdef API3D_OPENGL20
	"		oTexture2.y = scale.y + posi.y * scale.y;\n"
#else
	"		oTexture2.y = scale.y - posi.y * scale.y;\n"
#endif
	"   [SHADER] \n"
	"		val1 = coord(Tex1); \n"
	"		val4 = coord(Tex2); \n"
	"		val1.zw = psone.aa;	 \n"
	"		val4.zw = psone.aa;	 \n"
	"		val2 = sample(2,Tex0);	 \n"	
	
	"		val5 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val5.r; \n"
	"		val5 = cmp(val3.r,psamb,Diffuse); \n"
	
	"		val4.x = val4.x - pdd.w; \n"
	"		val4.x = val4.x - pdd.w; \n"
	
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	
	"		val2 = psone * val2; \n"
	"		val2 = val1 + val2; \n"
	
	"		Out = sample(0,Tex0); \n"
	"		val1 = sample(1,val2); \n"
	
	"		val5 = val5 * pdd.bbbb; \n"
	
	"		Out = Out + val1; \n"
	"		Out = Out * val5; \n"
	
	"	[RENDER_STATE]\n"
	
	"		ShadeMode				Smooth\n"
	"		Texture[0]				Tex\n"
	"		Texture[1]				Env\n"
	"		Texture[2]				Bump\n"
	"		Texture[3]				Shd\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	"		Mip[0]					Linear\n"
	"		Mip[1]					Linear\n"
	"		Mip[2]					Linear\n"
	"		Mag[0]					Linear\n"
	"		Mag[1]					Linear\n"
	"		Mag[2]					Linear\n"
	"		Min[0]					Linear\n"
	"		Min[1]					Linear\n"
	"		Min[2]					Linear\n"
	
	"[END]\n"
	"\n";
	
	
	char * script_zbuffer =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST color=1.0,0.0,1.0,1.0;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"       ldir=tPos - VECLIGHT;\n"
	"       dist.x=norme(ldir);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"	[DIFFUSE]\n"
	"		value.x=dist.x*MULTI.x;\n"
	"		value.y=zero.x;\n"
	"		value.z=zero.x;\n"
	"		value.w = one.x;\n"
	"		oDiffuse = value;\n"
	
	"   [SHADER] \n"
	"		Out = Diffuse;\n"
	
	"	[RENDER_STATE]\n"
	"		ShadeMode				Smooth\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	
	"[END]\n"
	"\n";
	

	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);
	
	TimeInit();

	/////////////////////////////////////////////////////////////////////
	// textures

	READ_PNG("data/env.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/meuf.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	
	float MULTI=1.0f/100.0f;

	CVertexBuffer *vbgrid;
	CObject3D grid;

	grid.Grid(50.0f,50.0f,16);
	grid.InverseOrientation();

	for (n=0;n<grid.nFaces;n++)
	{
		grid.Faces[n].nT=1;
		grid.Faces[n].nT2=grid.Faces[n].nT+VALUE_FINDING_BUMP_MAP;
	}
	vbgrid=Render.CreateMultiGroupFrom(&grid,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX|API3D_TEXTURE_NT2);

	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	rx=ry=rz=0.0f;

	CVertexBuffer effect;
	effect.BasicEffect();
	effect.SetVertexProgram(script_zbuffer);

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float tm=0.0f;

	int deltat=TimeGet();
	int ms=3000-deltat*20;
	if (ms>0) Sleep(ms);
	else tm+=(-ms/20.0f)*0.00425f;

	DrawImageFadeOut();


	InitFade();
	TimeInit();

	while (tm<5.7f)
	{
		if (tm>5.5f) INCREMENT_FADE=-1;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;
	
				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;

				p.Init(25*sin(rx),-15,25*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);



				int pt=(int) tm;
				float t=tm-pt;

				switch (pt)
				{
				case 0:
					a1=-9.757f;
					a2=0.457f;
					Zoom=8.8f;
					break;
				case 1:
					a1+=dt*0.02f;
					a2=-0.043f;
					Zoom=8.8f;
					break;
				case 2:
					a1=-7.997f;
					a2=-0.043f;
					Zoom=2.0f;
					break;
				case 3:
					a1+=dt*0.02f;
					a2=-0.543f;
					Zoom=2.0f;
					break;
				case 4:
					a1+=dt*0.02f;
					a2=-0.543f;
					Zoom=9.7f;
					break;
				case 5:
					a1+=dt*0.02f;
					a2=0.507f;
					Zoom=7.1f;
					break;
				};

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				effect.setFloat("MULTI",MULTI);

				Render.Distance=384;
				Render.SetParams(API3D_RENDERTARGET,SECONDARY3);
				Render.ClearZBuffer();
				Render.SetProjection();
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetParams(API3D_BLEND,OFF);
				Render.SetTexture(2001);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,0,0);

				Render.SetParams(API3D_ZBUFFER,ON);

				M.Id();
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				CMatrix MM;
				MM.View(Render.Lights[0].Pos,pos-Render.Lights[0].Pos,0);
				Render.LoadViewMatrix(MM);

				effect.setMatrixViewProj("VIEWPROJ");
				effect.setMatrix("WORLD",M);
				effect.setVector("VECLIGHT",Render.Lights[0].Pos);

				effectbump.setMatrixViewProj("VIEWPROJLIGHT");
				effectbump.setMatrix("VIEWPORTLIGHT",Render.VIEWPORT);

				Render.SetEffect(&effect);

				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();

				M.Id();
				M.Translation(0,5.0f,0);
				effect.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vbgrid);
				Render.DrawVertexBuffer();

				Render.SetEffect(NULL);
				Render.SetParams(API3D_ZBUFFER,ON);

				Render.Distance=768*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				InitGlow();
				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);

				Render.SetParams(API3D_ZBUFFER,ON);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

                CMatrix M;

				M.Id();
				
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				Render.SetTexture2(2002);
				Render.SetTexture(SECONDARYTEXTURE3);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_1);
				effectbump.setTextureAssociation("Shd",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);

				
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();

				M.Id();
				M.Translation(0,5.0f,0);
				effectbump.setMatrix("WORLD",M);				
				Render.SetVertexBuffer(vbgrid);
				Render.DrawVertexBuffer();

				Render.SetEffect(NULL);
				
				M.Id();
				M.Rotation(PI/2,0,0);
				M=M*MM;
				Render.LoadWorldMatrix(M);
				Render.SetTexture(1);
				Render.SetVertexBuffer(&vbsph);
				Render.DrawVertexBuffer();
				
                //////////////////////////////////////////////////////////////////////

				GlowRender(10,0.1f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
				dt=TimeGet();
				Fade(dt*2);

				rx+=0.035f*dt;

				tm+=(1.0f/241.0f)*dt; //224

				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
	}

_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);

	effect.Release();
	effectbump.Release();

	vb->Release();
	delete vb;
	vbgrid->Release();
	grid.Free();
	sph.Free();
	vbsph.Release();

	Scene.Clean();

	return res;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
bool FoetusCaustic(int EFFECT_DT)
{
	bool res=true;

	
	char * script_envmap_bump =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	MATRIX VIEWPROJLIGHT;\n"
	"	MATRIX VIEWPORTLIGHT;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR LIGHTPOS;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST med=0.5,0.3;\n"
	"	TEXTURE Tex;\n"
	"	TEXTURE Shd;\n"
	"	TEXTURE Env;\n"
	"	TEXTURE Bump;\n"
	"	PSCONST psone=0.2,0.2,0.8,1.0;\n"
	"	PSCONST pdd=0.0025,0.005,0.125,0.0025;\n"
	"	PSCONST psamb=0.15,0.15,0.15,1.0;\n"
	"	CONST scale=0.0009765625,0.5;\n"
	"	CONST cst=0.01,0.1,0.1;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"		tNorm=iNorm*3WORLD;\n"
	"       ldir=tPos - CAMERA;\n"
	"       ldir=normalise(ldir);\n"
	"       N=tNorm + tNorm + ldir;\n"
	"       N=normalise(N);\n"
	"       ripoux.x=(tNorm|VECLIGHT);\n"
	"       ldir=tPos - LIGHTPOS;\n"
	"       dist.x=norme(ldir);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"		posi=tPos*4VIEWPROJLIGHT;\n"
	"		div.w=reciprocal(posi);\n"
	"		posi=posi*div.w;\n"
	"	[DIFFUSE]\n"
	"		oDiffuse.x = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.y = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.z = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.w = MULTI.x*dist.x - cst.x;\n"
	"	[MAPPING0]\n"
	"		oTexture0.x=iTexture0.x;\n"
	"		oTexture0.y=iTexture0.y;\n"
	"	[MAPPING1]\n"
	"		oTexture1.x=med.x-med.y*tPos.x;\n"
	"		oTexture1.y=med.x+med.y*tPos.z;\n"
	"	[MAPPING2]\n"	
	"		oTexture2.x=scale.y+posi.x*scale.y;\n"
#ifdef API3D_OPENGL20
	"		oTexture2.y=scale.y+posi.y*scale.y;\n"
#else
	"		oTexture2.y=scale.y-posi.y*scale.y;\n"
#endif
	
	"   [SHADER] \n"
	"		val1 = coord(Tex1); \n"
	"		val4 = coord(Tex2); \n"
	"		val1.zw = psone.aa;	 \n"
	"		val4.zw = psone.aa;	 \n"
	"		val2 = sample(2,Tex0);	 \n"	
	
	"		val5 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val5.r; \n"
	"		val5 = cmp(val3.r,psamb,Diffuse); \n"
	
	"		val4.x = val4.x - pdd.w; \n"
	"		val4.x = val4.x - pdd.w; \n"
	
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	
	"		val2 = psone * val2; \n"
	"		val2 = val1 + val2; \n"
	
	"		Out = sample(0,Tex0); \n"
	"		val1 = sample(1,val2); \n"
	
	"		val5 = val5 * pdd.bbbb; \n"
	
	"		Out = Out + val1; \n"
	"		Out = Out * val5; \n"
	
	"	[RENDER_STATE]\n"
	
	"		ShadeMode				Smooth\n"
	"		Texture[0]				Tex\n"
	"		Texture[1]				Env\n"
	"		Texture[2]				Bump\n"
	"		Texture[3]				Shd\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	"		Mip[0]					Linear\n"
	"		Mip[1]					Linear\n"
	"		Mip[2]					Linear\n"
	"		Mag[0]					Linear\n"
	"		Mag[1]					Linear\n"
	"		Mag[2]					Linear\n"
	"		Min[0]					Linear\n"
	"		Min[1]					Linear\n"
	"		Min[2]					Linear\n"
	
	"[END]\n"
	"\n";
	
	
	char * script_zbuffer =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST color=1.0,0.0,1.0,1.0;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"       ldir=tPos - VECLIGHT;\n"
	"       dist.x=norme(ldir);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"	[DIFFUSE]\n"
	"		value.x=dist.x*MULTI.x;\n"
	"		value.y=zero.x;\n"
	"		value.z=zero.x;\n"
	"		value.w = one.x;\n"
	"		oDiffuse = value;\n"
	
	"   [SHADER] \n"
	"		Out = Diffuse;\n"
	
	"	[RENDER_STATE]\n"
	"		ShadeMode				Smooth\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	
	"[END]\n"
	"\n";
	
	
	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);
	
	TimeInit();

	/////////////////////////////////////////////////////////////////////
	// textures
	
	READ_PNG("data/submarine.png",&im,ALPHA1);
	Render.CreateTexture(2047,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);
	

	for (n=0;n<32;n++)
	{
		char str[128];
		if (n<10) sprintf(str,"data/caustic/caust0%d.png",n);
		else sprintf(str,"data/caustic/caust%d.png",n);
		READ_PNG(str,&im,ALPHA1);

		for (int p=0;p<im.X*im.Y;p++)
		{
			im.ptrImageDATAS[4*p+3]=im.ptrImageDATAS[4*p+0];
		}
		Render.CreateTexture(2000+n,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,ALPHA);
		free(im.ptrImageDATAS);
	}


	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/foetus.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	
	float MULTI=1.0f/100.0f;
	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	
	rx=ry=rz=0.0f;

	CVertexBuffer effect;
	effect.BasicEffect();
	effect.SetVertexProgram(script_zbuffer);

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float tm=0.0f;
	float caustic=0.0f;

	
	int deltat=TimeGet();
	int ms=500-deltat*20;
	if (ms>0) Sleep(ms);
	else tm+=0.00190f*(-ms/20.0f);

	InitFade();
	TimeInit();
	fade_start=1;


	while (tm<4)
	{
		if (tm>3.7f) INCREMENT_FADE=-1;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;
	
				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;

				p.Init(0,-15,-15);
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				int pt=(int) tm;
				float t=tm-pt;

				switch (pt)
				{
				case 0:
					a1=-9.757f;
					a2=0.457f;
					Zoom=8.8f;
					break;
				case 1:
					a1=PI/2;
					a2=-0.043f-t;
					Zoom=8.8f;
					break;
				case 2:
					a1=-2.3f;
					a2=-0.043f;
					Zoom=7.8f + 3*t;
					break;
				case 3:
					a1+=dt*0.02f;
					a2=0.507f;
					Zoom=7.1f;
					break;
				};

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				effect.setFloat("MULTI",MULTI);

				Render.Distance=384;
				Render.SetParams(API3D_RENDERTARGET,SECONDARY3);
				Render.ClearZBuffer();
				Render.SetProjection();
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetParams(API3D_BLEND,OFF);
				Render.SetTexture(2001);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,0,0);

				Render.SetParams(API3D_ZBUFFER,ON);

				M.Id();
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				CMatrix MM;
				MM.View(Render.Lights[0].Pos,pos-Render.Lights[0].Pos,0);
				Render.LoadViewMatrix(MM);

				effect.setMatrixViewProj("VIEWPROJ");
				effect.setMatrix("WORLD",M);
				effect.setVector("VECLIGHT",Render.Lights[0].Pos);

				effectbump.setMatrixViewProj("VIEWPROJLIGHT");
				effectbump.setMatrix("VIEWPORTLIGHT",Render.VIEWPORT);

				Render.SetEffect(&effect);

				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();

				Render.SetEffect(NULL);

				Render.Distance=768*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearStencilBuffer();
				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);

				InitGlow();
				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);
                
                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				Render.SetParams(API3D_ZBUFFER,ON);

				CMatrix M;

				M.Id();
				
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);


				int c=caustic;
				c=c%32;

				Render.SetTexture2(2000+c);
				Render.SetTexture(SECONDARYTEXTURE3);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_1);
				effectbump.setTextureAssociation("Shd",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
				
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				
				Render.SetEffect(NULL);
				
				Render.SetTexture(2000+c);
				Render.SetParams(API3D_ZBUFFER,WRITEOFF);
				Render.SetParams(API3D_CULL,OFF);
				Render.SetParams(API3D_BLEND,BLEND_GOURAUD);
				
				for (n=0;n<64;n++)
				{
					float KK=50.0f;
					float y=-15.0f + 20.0f*n/64.0f;
					CVertex a,b,c,d;
					a.Stok.Init(-KK,y,-KK);
					b.Stok.Init(KK,y,-KK);
					c.Stok.Init(KK,y,KK);
					d.Stok.Init(-KK,y,KK);
					
					a.Map.Init(-KK*0.2f,-KK*0.2f);
					b.Map.Init(KK*0.2f,-KK*0.2f);
					c.Map.Init(KK*0.2f,KK*0.2f);
					d.Map.Init(-KK*0.2f,KK*0.2f);

					Render.Quad_MappingStok(&a,&b,&c,&d,1,1,1,0.03f);
				}

				Render.SetParams(API3D_ZBUFFER,ON);
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				
				M.Id();
				M.RotationDegre(90,0,0);
				Render.LoadWorldMatrix(M);
				Render.SetTexture(2047);
				Render.SetVertexBuffer(&vbsph);
				Render.DrawVertexBuffer();
				
                //////////////////////////////////////////////////////////////////////
				
				GlowRenderaa(8,0.5f,1.0f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);

				Render.SetParams(API3D_RENDERTARGET,RENDER);
                
				dt=TimeGet();
				Fade(dt);

				rx+=0.035f*dt;
				
				caustic+=dt;

				switch (pt)
				{
				case 0:
					tm+=(1.0f/380.0f)*dt;
					break;
				case 1:
					tm+=(1.0f/1025.0f)*dt;
					break;
				case 2:
					tm+=(1.0f/700.0f)*dt;
					break;
				case 3:
					tm+=(1.0f/750.0f)*dt;
					break;
				};
				
				

				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
	}

_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2047);

	for (n=0;n<32;n++) Render.FreeTexture(2000+n);

	effect.Release();
	effectbump.Release();

	vb->Release();
	delete vb;

	sph.Free();
	vbsph.Release();

	Scene.Clean();

	return res;
}


CObject3D * OBJECT_STARS;

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool Stars(int EFFECT_DT)
{
	bool res=true;


char * script_envmap_bump =
"[VERTEXFORMAT]\n"
"	MORPH\n"
"[DEFINES]\n"
"	MATRIX WORLD;\n"
"	MATRIX VIEWPROJ;\n"
"   VECTOR Interpolant;\n"
"	CONST zero;\n"
"	CONST one=1.0,1.0,1.0,1.0;\n"
"	CONST med=0.5,0.3;\n"
"	TEXTURE Env;\n"
"	\n"

"[TECHNIQUE]	Model3\n"
"[PASS0]\n"
"	[POSITION]\n"
    
"		tPos=interpolate(iPos,iPos2,Interpolant,WORLD);\n"
"		tNorm=normal_interpolate(iNorm,iNorm2,Interpolant,WORLD);\n"
"		tNorm = normalise(tNorm);\n"
    
"		oPos=tPos*4VIEWPROJ;\n"
"		N=tNorm*3VIEWPROJ;\n"
"	[DIFFUSE]\n"
"		oDiffuse=one;\n"
"	[MAPPING0]\n"
"		oTexture0.x=med.x-med.x*N.x;\n"
"		oTexture0.y=med.x+med.x*N.y;\n"

"   [SHADER] \n"
"		Out = sample(0,Tex0);\n"

"	[RENDER_STATE]\n"

"		ShadeMode				Smooth\n"
"		Texture[0]				Env\n"
"		ZBuffer					True\n"
"		TextureCoordinate[0]	TexCoo0\n"
"		Mip[0]					Linear\n"
"		Mip[1]					Linear\n"
"		Mip[2]					Linear\n"
"		Mag[0]					Linear\n"
"		Mag[1]					Linear\n"
"		Mag[2]					Linear\n"
"		Min[0]					Linear\n"
"		Min[1]					Linear\n"
"		Min[2]					Linear\n"

"[END]\n"
"\n";

	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=5.0f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);

	TimeInit();

	/////////////////////////////////////////////////////////////////////
	// textures

	READ_PNG("data/stars.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);
	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	CObject3D * obj=OBJECT_STARS;
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT=0;
		obj->Faces[n].nT2=VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2|API3D_MORPH|API3D_STREAMS|API3D_CONSTANT);
	
	float MULTI=1.0f/50.0f;


	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	
	rx=ry=rz=0.0f;

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
    effectbump.SetVertexProgram(script_envmap_bump);
	
	int deltat=TimeGet();
	int ms=3000-deltat*20;
	if (ms>0) Sleep(ms);
	else TIMESPENT=-ms/20.0f;

	DrawImageFadeOut();


	float tmorph=0.0f;

	Render.Distance=768;

	rx=1.5f;

	InitFade();
	TimeInit();

	while (TIMESPENT<EFFECT_DT)
	{
		if (TIMESPENT>EFFECT_DT-32) INCREMENT_FADE=-1;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;
	
				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;

				p.Init(25*sin(rx),-15,25*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////

				//int m;

				int k1=(int) tmorph;
				int k2=(k1+1)%3;
				float t=tmorph -k1;
                
                vb->stream1=k1;
                vb->stream2=k2;

/*
				CObject3D * obj=OBJECT_STARS;

				for (m=0;m<obj->nVertices;m++)
				{
					VECTORINTERPOL(obj->Vertices[m].Stok,t,obj->VerticesKeys[k2][m].Stok,obj->VerticesKeys[k1][m].Stok);
					VECTORINTERPOL(obj->Vertices[m].Norm,t,obj->VerticesKeys[k2][m].Norm,obj->VerticesKeys[k1][m].Norm);
					VECTORNORMALISE(obj->Vertices[m].Norm);
				}

				vb->LockVertices();
				for (m=0;m<vb->nVertices;m++)
				{
					vb->SetVertex(m,obj->Vertices[vb->CorresVertices[m]].Stok);
					vb->SetNormal(m,obj->Vertices[vb->CorresVertices[m]].Norm);
				}
				vb->UnlockVertices();
/**/
				CVector pos;
				
				Render.SetParams(API3D_ZBUFFER,ON);
				
				Render.Distance=768*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearStencilBuffer();
				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				InitGlow();
				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);

				Render.SetParams(API3D_ZBUFFER,ON);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);
				CMatrix M;

				M.Id();
				
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				Render.SetTexture(2002);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_0);
				effectbump.setMatrixViewProj("VIEWPROJ");
	
                effectbump.setFloat("Interpolant",t);
                
				int ND=5;
				float KK=12.0f;
				float KK2=6.0f;

				for (int x=-ND;x<=ND;x++)
					for (int y=-ND;y<=ND;y++)
						for (int z=-ND;z<=ND;z++)
						{
							if ((x==0)&&(y==0)&&(z==0))
							{
								M.Id();
								M.Rotation(ry,ry,rz);
								effectbump.setMatrix("WORLD",M);
								Render.SetEffect(&effectbump);
								Render.SetVertexBuffer(vb);
								Render.DrawVertexBuffer();
							}
							else
							{
								M.Id();
								M.Rotation(ry+x+y+z,ry+x+y+z,rz+x+y+z);
								M.Translation(x*KK + KK2*sin(rx+x+y+z),y*KK + KK2*sin(ry+x+y+z),z*KK + KK2*sin(rz+x+y+z));
								effectbump.setMatrix("WORLD",M);
								Render.SetEffect(&effectbump);
								Render.SetVertexBuffer(vb);
								Render.DrawVertexBuffer();
							}
						}
				Render.SetEffect(NULL);
				
				M.Id();
				Render.LoadWorldMatrix(M);
				Render.SetTexture(2002);
				Render.SetVertexBuffer(&vbsph);
				Render.DrawVertexBuffer();
		        //////////////////////////////////////////////////////////////////////

				GlowRender(9,0.5f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
				dt=TimeGet();

				tmorph+=0.02f*dt;
				while (tmorph>=3)
				{
					tmorph-=3;
				}

				a1+=0.01f*dt;
				rx+=0.025f*dt;
				ry+=0.015f*dt;
				rz+=0.01f*dt;

				Fade(dt*4);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
	}
	TabKeys[KEY_ESCAPE]=0;

_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);

	vb->Release();
	delete vb;
	sph.Free();
	vbsph.Release();

	effectbump.Release();

	Scene.Clean();

	OBJECT_STARS->Free();
	delete OBJECT_STARS;

	return res;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool Monarch(int EFFECT_DT,int tag,char * filename_image_fond)
{
	bool res=true;

	
	char * script_envmap_bump =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	MATRIX VIEWPROJLIGHT;\n"
	"	MATRIX VIEWPORTLIGHT;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR LIGHTPOS;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST med=0.5,0.3;\n"
	"	TEXTURE Tex;\n"
	"	TEXTURE Bump;\n"
	"	TEXTURE Env;\n"
	"	PSCONST psone=0.2,0.2,0.8,0.0;\n"
	"	PSCONST psamb=0.1,0.1,0.1,1.0;\n"
	"	CONST scale=0.0009765625,0.5;\n"
	"	CONST cst=0.03,0.1,0.1;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"		tNorm=iNorm*3WORLD;\n"
	"       ldir=tPos - CAMERA;\n"
	"       ldir=normalise(ldir);\n"
	"       N=tNorm + tNorm + ldir;\n"
	"       N=normalise(N);\n"
	"       ripoux.x=(tNorm|VECLIGHT);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"	[DIFFUSE]\n"
	"		oDiffuse.x=AMBIENT.x - min(ripoux.x,zero.x);\n"
	"		oDiffuse.y=AMBIENT.y - min(ripoux.x,zero.x);\n"
	"		oDiffuse.z=AMBIENT.z - min(ripoux.x,zero.x);\n"
	"		oDiffuse.w = one.x;\n"
	"	[MAPPING0]\n"
	"		oTexture0.x=iTexture0.x;\n"
	"		oTexture0.y=iTexture0.y;\n"
	"	[MAPPING1]\n"
	"		oTexture1.x=med.x-med.x*N.x;\n"
	"		oTexture1.y=med.x+med.x*N.y;\n"
	
	"   [SHADER] \n"
	"		val1 = coord(Tex1);\n"
	"		val2 = sample(2,Tex0);\n"		
	"		val1.ba = psone.aa;\n"			
	"		val2 = psone * val2;\n"
	"		val2 = val1 + val2;\n"
	"		Out = sample(0,Tex0);\n"
	"		val1 = sample(1,val2);\n"
	"       val4 = Diffuse;\n"
	"		Out = Out + val1;\n"
	"		Out = Out * val4;\n"
	
	
	"	[RENDER_STATE]\n"
	
	"		ShadeMode				Smooth\n"
	"		Texture[0]				Tex\n"
	"		Texture[1]				Env\n"
	"		Texture[2]				Bump\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	"		Mip[0]					Linear\n"
	"		Mip[1]					Linear\n"
	"		Mip[2]					Linear\n"
	"		Mag[0]					Linear\n"
	"		Mag[1]					Linear\n"
	"		Mag[2]					Linear\n"
	"		Min[0]					Linear\n"
	"		Min[1]					Linear\n"
	"		Min[2]					Linear\n"
	
	"[END]\n"
	"\n";
	
	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=5.0f;
	float a1=PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);

	TimeInit();

	/////////////////////////////////////////////////////////////////////
	// textures

	READ_PNG("data/rnl.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);
	
	READ_PNG(filename_image_fond,&im,ALPHA1);
	Render.CreateTexture(2000,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	a1+=tag*PI/2;
	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);
#define K 8 
	int K2=K/2;
	CVector cube[K*K*K];
	for (int x=0;x<K;x++)
		for (int y=0;y<K;y++)
			for (int z=0;z<K;z++)
				cube[x+y*K+z*K*K].Init(4*(x-K2),4*(y-K2),4*(z-K2));
	
	for (int i=0;i<K*K*K;i++)
		for (int j=0;j<K*K*K;j++)
			if ((rand()%100)>50)
			{
				CVector u;
				u=cube[i];
				cube[i]=cube[j];
				cube[j]=u;
			}

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/monarch.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2|API3D_ENABLEUPDATE);	
	
	float MULTI=1.0f/50.0f;

	rx=ry=rz=0.0f;

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float tmorph=0.0f;

	Render.Distance=768;

	rx=1.5f;

	int deltat=TimeGet();
	int ms=2500-deltat*20;

	if (ms>0) Sleep(ms);
	else TIMESPENT=-ms/20.0f;

	InitFade();
	TimeInit();

	while (TIMESPENT<EFFECT_DT)
	{
		if (TIMESPENT>EFFECT_DT-32) INCREMENT_FADE=-1;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;
	
				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;



				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;


				p.Init(25*sin(rx),-15,25*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////


				CVector pos;

				effectbump.setFloat("MULTI",MULTI);

				
				Render.Distance=768*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);

				

				Render.SetTexture(2000);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,1,1);
				Render.SetParams(API3D_ZBUFFER,ON);

				InitGlow();
				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);
                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				Render.SetParams(API3D_ZBUFFER,ON);

				CMatrix M;

				pos.Init(0,0,0);

				Render.SetTexture(2002);
				
				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);

				for (n=0;n<32;n++)
				{


					int m;

					int k1=(int) tmorph;
					float t=tmorph -k1;
					k1=(k1+n)%2;
					int k2=(k1+1)%2;
					

					CObject3D * obj=Scene.WorldObjects[0];

					for (m=0;m<obj->nVertices;m++)
					{
						VECTORINTERPOL(obj->Vertices[m].Stok,t,obj->VerticesKeys[k2][m].Stok,obj->VerticesKeys[k1][m].Stok);
						VECTORINTERPOL(obj->Vertices[m].Norm,t,obj->VerticesKeys[k2][m].Norm,obj->VerticesKeys[k1][m].Norm);
						VECTORNORMALISE(obj->Vertices[m].Norm);
					}

					vb->LockVertices();
					for (m=0;m<vb->nVertices;m++)
					{
						vb->SetVertex(m,obj->Vertices[vb->CorresVertices[m]].Stok);
						vb->SetNormal(m,obj->Vertices[vb->CorresVertices[m]].Norm);
					}
					vb->UnlockVertices();


					M.Id();
					M.Translation(cube[n].x,cube[n].y+ sin(t*PI),cube[n].z+EFFECT_DT*0.5f-TIMESPENT);
					effectbump.setMatrix("WORLD",M);
					Render.DrawVertexBuffer();
				}
	
				Render.SetEffect(NULL);
				
				
                //////////////////////////////////////////////////////////////////////

				GlowRendeval2(3,0.2f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
				dt=TimeGet();

				tmorph+=0.1f*dt;
				while (tmorph>2)
				{
					tmorph-=2;
				}

				ry+=0.02f*dt;
				rz+=0.02f*dt;

				Fade(dt*8);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
	}


_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);
	Render.FreeTexture(2000);

	vb->Release();
	delete vb;
	effectbump.Release();
	Scene.Clean();

	return res;

}




void InitMonarchDebut()
{
	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/monarch.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
bool MonarchDebut(int EFFECT_DT,int tag,char * filename_image_fond)
{
	bool res=true;

char * script_envmap_bump =
"[VERTEXFORMAT]\n"
"	XYZ NORMAL TEX0\n"
"[DEFINES]\n"
"	MATRIX WORLD;\n"
"	MATRIX VIEWPROJ;\n"
"	MATRIX VIEWPROJLIGHT;\n"
"	MATRIX VIEWPORTLIGHT;\n"
"	VECTOR VECLIGHT;\n"
"	VECTOR LIGHTPOS;\n"
"	VECTOR CAMERA;\n"
"	VECTOR AMBIENT;\n"
"	VECTOR MULTI;\n"
"	CONST zero;\n"
"	CONST one=1.0,1.0,1.0,1.0;\n"
"	CONST med=0.5,0.3;\n"
"	TEXTURE Tex;\n"
"	TEXTURE Bump;\n"
"	TEXTURE Env;\n"
"	PSCONST psone=0.2,0.2,0.8,0.0;\n"
"	PSCONST psamb=0.1,0.1,0.1,1.0;\n"
"	CONST scale=0.0009765625,0.5;\n"
"	CONST cst=0.03,0.1,0.1;\n"
"	\n"

"[TECHNIQUE]	Model3\n"
"[PASS0]\n"
"	[POSITION]\n"
"		tPos=iPos*4WORLD;\n"
"		tNorm=iNorm*3WORLD;\n"
"       ldir=tPos - CAMERA;\n"
"       ldir=normalise(ldir);\n"
"       N=tNorm + tNorm + ldir;\n"
"       N=normalise(N);\n"
"       ripoux.x=(tNorm|VECLIGHT);\n"
"		oPos=tPos*4VIEWPROJ;\n"
"	[DIFFUSE]\n"
"		oDiffuse.x=AMBIENT.x - min(ripoux.x,zero.x);\n"
"		oDiffuse.y=AMBIENT.y - min(ripoux.x,zero.x);\n"
"		oDiffuse.z=AMBIENT.z - min(ripoux.x,zero.x);\n"
"		oDiffuse.w = one.x;\n"
"	[MAPPING0]\n"
"		oTexture0.x=iTexture0.x;\n"
"		oTexture0.y=iTexture0.y;\n"
"	[MAPPING1]\n"
"		oTexture1.x=med.x-med.x*N.x;\n"
"		oTexture1.y=med.x+med.x*N.y;\n"

"   [SHADER] \n"
"		val1 = coord(Tex1);\n"
"		val2 = sample(2,Tex0);\n"		
"		val1.ba = psone.aa;\n"			
"		val2 = psone * val2;\n"
"		val2 = val1 + val2;\n"
"		Out = sample(0,Tex0);\n"
"		val1 = sample(1,val2);\n"
"       val4 = Diffuse;\n"
"		Out = Out + val1;\n"
"		Out = Out * val4;\n"


"	[RENDER_STATE]\n"

"		ShadeMode				Smooth\n"
"		Texture[0]				Tex\n"
"		Texture[1]				Env\n"
"		Texture[2]				Bump\n"
"		ZBuffer					True\n"
"		TextureCoordinate[0]	TexCoo0\n"
"		Mip[0]					Linear\n"
"		Mip[1]					Linear\n"
"		Mip[2]					Linear\n"
"		Mag[0]					Linear\n"
"		Mag[1]					Linear\n"
"		Mag[2]					Linear\n"
"		Min[0]					Linear\n"
"		Min[1]					Linear\n"
"		Min[2]					Linear\n"

"[END]\n"
"\n";

	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=5.0f;
	float a1=PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);

	TimeInit();

	/////////////////////////////////////////////////////////////////////
	// textures

	READ_PNG("data/rnl.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);
	
	READ_PNG(filename_image_fond,&im,ALPHA1);
	Render.CreateTexture(2000,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	a1+=tag*PI/2;
	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);
#define K 8 
	int K2=K/2;
	CVector cube[K*K*K];
	for (int x=0;x<K;x++)
		for (int y=0;y<K;y++)
			for (int z=0;z<K;z++)
				cube[x+y*K+z*K*K].Init(4*(x-K2),4*(y-K2),4*(z-K2));
	
	for (int i=0;i<K*K*K;i++)
		for (int j=0;j<K*K*K;j++)
			if ((rand()%100)>50)
			{
				CVector u;
				u=cube[i];
				cube[i]=cube[j];
				cube[j]=u;
			}

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	
	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2|API3D_ENABLEUPDATE);	
	
	float MULTI=1.0f/50.0f;

	rx=ry=rz=0.0f;

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float tmorph=0.0f;

	Render.Distance=768;

	rx=1.5f;

	int deltat=TimeGet();
	int ms=500-deltat*20;

	if (ms>0) Sleep(ms);
	else TIMESPENT=-ms/20.0f;

	InitFade();
	TimeInit();

	while (TIMESPENT<EFFECT_DT)
	{
		if (TIMESPENT>EFFECT_DT-32) INCREMENT_FADE=-1;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;
	
				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;



				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;


				p.Init(25*sin(rx),-15,25*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				
				Render.Distance=768*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);

				Render.SetParams(API3D_BLEND,OFF);

							
				Render.SetTexture(2000);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,1,1);
				Render.SetParams(API3D_ZBUFFER,ON);

				InitGlow();
				
                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

                Render.LoadViewMatrix(MView);

				CMatrix M;

				pos.Init(0,0,0);

				Render.SetTexture(2002);
				
				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_0);
				

				effectbump.setMatrixViewProj("VIEWPROJ");
				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);

				for (n=0;n<32;n++)
				{


					int m;

					int k1=(int) tmorph;
					float t=tmorph -k1;
					k1=(k1+n)%2;
					int k2=(k1+1)%2;
					

					CObject3D * obj=Scene.WorldObjects[0];

					for (m=0;m<obj->nVertices;m++)
					{
						VECTORINTERPOL(obj->Vertices[m].Stok,t,obj->VerticesKeys[k2][m].Stok,obj->VerticesKeys[k1][m].Stok);
						VECTORINTERPOL(obj->Vertices[m].Norm,t,obj->VerticesKeys[k2][m].Norm,obj->VerticesKeys[k1][m].Norm);
						VECTORNORMALISE(obj->Vertices[m].Norm);
					}

					vb->LockVertices();
					for (m=0;m<vb->nVertices;m++)
					{
						vb->SetVertex(m,obj->Vertices[vb->CorresVertices[m]].Stok);
						vb->SetNormal(m,obj->Vertices[vb->CorresVertices[m]].Norm);
					}
					vb->UnlockVertices();


					M.Id();
					M.Translation(cube[n].x,cube[n].y+ sin(t*PI),cube[n].z+EFFECT_DT*0.5f-TIMESPENT);
					effectbump.setMatrix("WORLD",M);
					Render.DrawVertexBuffer();
				}
	
				Render.SetEffect(NULL);
				
				
                //////////////////////////////////////////////////////////////////////

				GlowRendeval2(3,0.2f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
				dt=TimeGet();

				tmorph+=0.1f*dt;
				while (tmorph>2)
				{
					tmorph-=2;
				}

				ry+=0.02f*dt;
				rz+=0.02f*dt;

				Fade(dt*8);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
	}


_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);
	Render.FreeTexture(2000);

	vb->Release();
	delete vb;
	effectbump.Release();

	return res;

}

bool Chevy(int EFFECT_DT)
{
	bool res=true;

	
	char * script_envmap_bump =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	MATRIX VIEWPROJLIGHT;\n"
	"	MATRIX VIEWPORTLIGHT;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR LIGHTPOS;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST med=0.5,0.3;\n"
	"	TEXTURE Tex;\n"
	"	TEXTURE Shd;\n"
	"	TEXTURE Env;\n"
	"	TEXTURE Bump;\n"
	"	PSCONST psone=0.2,0.2,0.8,1.0;\n"
	"	PSCONST pdd=0.0025,0.005,0.125,0.0025;\n"
	"	PSCONST psamb=0.15,0.15,0.15,1.0;\n"
	"	CONST scale=0.0009765625,0.5;\n"
	"	CONST cst=0.01,0.1,0.1;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos = iPos *4 WORLD;\n"
	"		tNorm = iNorm *3 WORLD;\n"
	"       ldir = tPos - CAMERA;\n"
	"       ldir = normalise( ldir );\n"
	"       N = tNorm + tNorm + ldir;\n"
	"       N = normalise( N );\n"
	"       ripoux.x = ( tNorm | VECLIGHT );\n"
	"       ldir = tPos - LIGHTPOS;\n"
	"       dist.x = norme( ldir );\n"
	"		oPos = tPos *4 VIEWPROJ;\n"
	"		posi = tPos *4 VIEWPROJLIGHT;\n"
	"		div.w = reciprocal( posi );\n"
	"		posi.x = posi.x * div.w;\n"
	"		posi.y = posi.y * div.w;\n"
	"	[DIFFUSE]\n"
	"		oDiffuse.x = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.y = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.z = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.w = MULTI.x * dist.x - cst.x;\n"
	"	[MAPPING0]\n"
	"		oTexture0.x = iTexture0.x;\n"
	"		oTexture0.y = iTexture0.y;\n"
	"	[MAPPING1]\n"
	"		oTexture1.x = med.x - med.x * N.x;\n"
	"		oTexture1.y = med.x + med.x * N.y;\n"
	"	[MAPPING2]\n"	
	"		oTexture2.x = scale.y + posi.x * scale.y;\n"
#ifdef API3D_OPENGL20
	"		oTexture2.y = scale.y + posi.y * scale.y;\n"
#else
	"		oTexture2.y = scale.y - posi.y * scale.y;\n"
#endif
	"   [SHADER] \n"
	"		val1 = coord(Tex1); \n"
	"		val4 = coord(Tex2); \n"
	"		val1.zw = psone.aa;	 \n"
	"		val4.zw = psone.aa;	 \n"
	"		val2 = sample(2,Tex0);	 \n"	
	
	"		val5 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val5.r; \n"
	"		val5 = cmp(val3.r,psamb,Diffuse); \n"
	
	"		val4.x = val4.x - pdd.w; \n"
	"		val4.y = val4.y - pdd.w; \n"
	
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	
	"		val2 = psone * val2; \n"
	"		val2 = val1 + val2; \n"
	
	"		Out = sample(0,Tex0); \n"
	"		val1 = sample(1,val2); \n"
	
	"		val5 = val5 * pdd.bbbb; \n"
	
	"		Out = Out + val1; \n"
	"		Out = Out * val5; \n"
	
	"	[RENDER_STATE]\n"
	
	"		ShadeMode				Smooth\n"
	"		Texture[0]				Tex\n"
	"		Texture[1]				Env\n"
	"		Texture[2]				Bump\n"
	"		Texture[3]				Shd\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	"		Mip[0]					Linear\n"
	"		Mip[1]					Linear\n"
	"		Mip[2]					Linear\n"
	"		Mag[0]					Linear\n"
	"		Mag[1]					Linear\n"
	"		Mag[2]					Linear\n"
	"		Min[0]					Linear\n"
	"		Min[1]					Linear\n"
	"		Min[2]					Linear\n"
	
	"[END]\n"
	"\n";
	
	
	char * script_zbuffer =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST color=1.0,0.0,1.0,1.0;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"       ldir=tPos - VECLIGHT;\n"
	"       dist.x=norme(ldir);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"	[DIFFUSE]\n"
	"		value.x=dist.x*MULTI.x;\n"
	"		value.y=zero.x;\n"
	"		value.z=zero.x;\n"
	"		value.w = one.x;\n"
	"		oDiffuse = value;\n"
	
	"   [SHADER] \n"
	"		Out = Diffuse;\n"
	
	"	[RENDER_STATE]\n"
	"		ShadeMode				Smooth\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	
	"[END]\n"
	"\n";
	
	
	

	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	TimeInit();
	p.Init(0,0,0);

	Render.Distance=512;
	/////////////////////////////////////////////////////////////////////
	// textures

	READ_PNG("data/rnl.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/chevy.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	
	float xmin,xmax;
	xmin=10000000;
	xmax=-10000000;
	float zmin,zmax;
	zmin=10000000;
	zmax=-10000000;
	for (n=0;n<obj->nVertices;n++)
	{
		if (obj->Vertices[n].Stok.x<xmin) xmin=obj->Vertices[n].Stok.x;
		if (obj->Vertices[n].Stok.x>xmax) xmax=obj->Vertices[n].Stok.x;

		if (obj->Vertices[n].Stok.z<zmin) zmin=obj->Vertices[n].Stok.z;
		if (obj->Vertices[n].Stok.z>zmax) zmax=obj->Vertices[n].Stok.z;
	}



	float MULTI=1.0f/50.0f;

	CVertexBuffer *vbgrid;
	CObject3D grid;

	grid.Grid(50.0f,50.0f,16);
	grid.InverseOrientation();

	for (n=0;n<grid.nFaces;n++)
	{
		grid.Faces[n].nT=1;
		grid.Faces[n].nT2=grid.Faces[n].nT+VALUE_FINDING_BUMP_MAP;
	}
	vbgrid=Render.CreateMultiGroupFrom(&grid,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX|API3D_TEXTURE_NT2);

	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	rx=ry=rz=0.0f;

	rx=1.0f;

	CVertexBuffer effect;
	effect.BasicEffect();
	effect.SetVertexProgram(script_zbuffer);

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float values[6][4]={
		{ -3.147f,-0.143f,6.5f,0.0f },
		{ -3.147f,-0.143f,6.5f,5.2f },
		{ -3.147f,-0.143f,7.3f,8.2f },
		{ -3.397f,-0.143f,7.3f,10.2f },
		{ -2.797f,-0.143f,7.3f,11.2f },
		{ -3.347f,0.207f,6.9f,12.85f } };


	float tt=0.0f;


	int deltat=TimeGet();
	int ms=500-deltat*20;

	if (ms>0) Sleep(ms);
	else tt=tt+(-ms/20.0f)*0.012f;


	InitFade();

	TimeInit();

	while (tt<5)
	{
		//if (TIMESPENT>EFFECT_DT-32) INCREMENT_FADE=-1;

		if (tt<0.5f) INCREMENT_FADE=1.0f;
		if (tt>4.5f) INCREMENT_FADE=-1.0f;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;

				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;

				float t=tt-(int) tt;
				int zz=(int) tt;
				a1=values[zz][0] + t*(values[zz+1][0] - values[zz][0]);
				a2=values[zz][1] + t*(values[zz+1][1] - values[zz][1]);
				Zoom=values[zz][2] + t*(values[zz+1][2] - values[zz][2]);
				rx=values[zz][3] + t*(values[zz+1][3] - values[zz][3]);


				CVector C;
				C.x=(float) (sin(values[0][0])*cos(values[0][1])*values[0][2]);
				C.y=(float) (sin(values[0][1])*values[0][2]);
				C.z=(float) (cos(values[0][0])*cos(values[0][1])*values[0][2]);

				p.Init(C.x+4*sin(rx),C.y-10,C.z+4*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				MView.Id();
				MView.View(Camera,(Target-Camera),0);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				effect.setFloat("MULTI",MULTI);

				Render.Distance=384/2;
				Render.SetParams(API3D_RENDERTARGET,SECONDARY3);
				Render.ClearZBuffer();
				Render.SetProjection();
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetParams(API3D_BLEND,OFF);
				Render.SetTexture(2001);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,0,0);

				Render.SetParams(API3D_ZBUFFER,ON);

				M.Id();
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				CMatrix MM;
				MM.View(Render.Lights[0].Pos,pos-Render.Lights[0].Pos,0);
				Render.LoadViewMatrix(MM);

				effect.setMatrixViewProj("VIEWPROJ");
				effect.setMatrix("WORLD",M);
				effect.setVector("VECLIGHT",Render.Lights[0].Pos);

				effectbump.setMatrixViewProj("VIEWPROJLIGHT");
				effectbump.setMatrix("VIEWPORTLIGHT",Render.VIEWPORT);

				Render.SetEffect(&effect);

                Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				/*
				M.Id();
				M.Translation(0,5.0f,0);
				effect.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vbgrid);
				Render.DrawVertexBuffer();
				/**/
				Render.SetEffect(NULL);
			
			
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.Distance=900*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				InitGlow();

				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetTexture(1200);
				Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,0.2f,0.2f,0.2f);
				Render.SetParams(API3D_ZBUFFER,ON);

				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);

				Render.SetParams(API3D_ZBUFFER,ON);

				CMatrix M;

				M.Id();
				M.RotationDegre(-4+8*abs(sin(rz)),0,0);
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				Render.SetTexture2(2002);
				Render.SetTexture(SECONDARYTEXTURE3);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_1);
				effectbump.setTextureAssociation("Shd",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);

				
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				vb->LockVertices();

				for (n=0;n<obj->nVertices;n++)
				{
					float t=(obj->Vertices[n].Stok.z - zmin)/(zmax-zmin);
					float tx=(obj->Vertices[n].Stok.x - xmin)/(xmax-xmin);
					CVector v;

					v=obj->Vertices[n].Stok;
					v.y-=0.5f*sin(tx*PI*1.6f+rz*2)*sin(t*2*PI+rz*0.7f);

					vb->SetVertex(n,v);
				}

				vb->UnlockVertices();

				Render.SetParams(API3D_CULL,CCW);
				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				Render.SetEffect(NULL);
			
                //////////////////////////////////////////////////////////////////////

				GlowRender(3,0.2f,1.5f);

				Render.SetParams(API3D_BLEND,OFF);
                Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
                
				dt=TimeGet();

				tt=tt+dt*(1.0f/60.0f); //91.0f

				Fade(dt*8);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
		
		rz+=0.1f*dt;
	}
	
_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);

	effect.Release();
	effectbump.Release();

	vb->Release();
	delete vb;
	vbgrid->Release();
	grid.Free();
	sph.Free();
	vbsph.Release();

	Scene.Clean();

    return res;

}



bool Skull(int EFFECT_DT)
{
	bool res=true;

	char * script_envmap_bump =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	MATRIX VIEWPROJLIGHT;\n"
	"	MATRIX VIEWPORTLIGHT;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR LIGHTPOS;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST med=0.5,0.3;\n"
	"	TEXTURE Tex;\n"
	"	TEXTURE Shd;\n"
	"	TEXTURE Env;\n"
	"	TEXTURE Bump;\n"
	"	PSCONST psone=0.2,0.2,0.8,1.0;\n"
	"	PSCONST pdd=0.0025,0.005,0.125,0.0025;\n"
	"	PSCONST psamb=0.15,0.15,0.15,1.0;\n"
	"	CONST scale=0.0009765625,0.5;\n"
	"	CONST cst=0.01,0.1,0.1;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos = iPos *4 WORLD;\n"
	"		tNorm = iNorm *3 WORLD;\n"
	"       ldir = tPos - CAMERA;\n"
	"       ldir = normalise( ldir );\n"
	"       N = tNorm + tNorm + ldir;\n"
	"       N = normalise( N );\n"
	"       ripoux.x = ( tNorm | VECLIGHT );\n"
	"       ldir = tPos - LIGHTPOS;\n"
	"       dist.x = norme( ldir );\n"
	"		oPos = tPos *4 VIEWPROJ;\n"
	"		posi = tPos *4 VIEWPROJLIGHT;\n"
	"		div.w = reciprocal( posi );\n"
	"		posi.x = posi.x * div.w;\n"
	"		posi.y = posi.y * div.w;\n"
	"	[DIFFUSE]\n"
	"		oDiffuse.x = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.y = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.z = AMBIENT.x - min( ripoux.x , zero.x );\n"
	"		oDiffuse.w = MULTI.x * dist.x - cst.x;\n"
	"	[MAPPING0]\n"
	"		oTexture0.x = iTexture0.x;\n"
	"		oTexture0.y = iTexture0.y;\n"
	"	[MAPPING1]\n"
	"		oTexture1.x = med.x - med.x * N.x;\n"
	"		oTexture1.y = med.x + med.x * N.y;\n"
	"	[MAPPING2]\n"	
	"		oTexture2.x = scale.y + posi.x * scale.y;\n"
#ifdef API3D_OPENGL20
	"		oTexture2.y = scale.y + posi.y * scale.y;\n"
#else
	"		oTexture2.y = scale.y - posi.y * scale.y;\n"
#endif
	"   [SHADER] \n"
	"		val1 = coord(Tex1); \n"
	"		val4 = coord(Tex2); \n"
	"		val1.zw = psone.aa;	 \n"
	"		val4.zw = psone.aa;	 \n"
	"		val2 = sample(2,Tex0);	 \n"	
	
	"		val5 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val5.r; \n"
	"		val5 = cmp(val3.r,psamb,Diffuse); \n"
	
	"		val4.x = val4.x - pdd.w; \n"
	"		val4.x = val4.x - pdd.w; \n"
	
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.g; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.y = val4.y + pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	"		val4.x = val4.x - pdd.a; \n"
	"		val6 = sample(3,val4); \n"
	"		val3.r = Diffuse.a - val6.r; \n"
	"		val6 = cmp(val3.r,psamb,Diffuse); \n"
	"		val5 = val5 + val6; \n"
	
	"		val2 = psone * val2; \n"
	"		val2 = val1 + val2; \n"
	
	"		Out = sample(0,Tex0); \n"
	"		val1 = sample(1,val2); \n"
	
	"		val5 = val5 * pdd.bbbb; \n"
	
	"		Out = Out + val1; \n"
	"		Out = Out * val5; \n"
	
	"	[RENDER_STATE]\n"
	
	"		ShadeMode				Smooth\n"
	"		Texture[0]				Tex\n"
	"		Texture[1]				Env\n"
	"		Texture[2]				Bump\n"
	"		Texture[3]				Shd\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	"		Mip[0]					Linear\n"
	"		Mip[1]					Linear\n"
	"		Mip[2]					Linear\n"
	"		Mag[0]					Linear\n"
	"		Mag[1]					Linear\n"
	"		Mag[2]					Linear\n"
	"		Min[0]					Linear\n"
	"		Min[1]					Linear\n"
	"		Min[2]					Linear\n"
	
	"[END]\n"
	"\n";
	
	
	char * script_zbuffer =
	"[VERTEXFORMAT]\n"
	"	XYZ NORMAL TEX0\n"
	"[DEFINES]\n"
	"	MATRIX WORLD;\n"
	"	MATRIX VIEWPROJ;\n"
	"	VECTOR VECLIGHT;\n"
	"	VECTOR CAMERA;\n"
	"	VECTOR AMBIENT;\n"
	"	VECTOR MULTI;\n"
	"	CONST zero;\n"
	"	CONST one=1.0,1.0,1.0,1.0;\n"
	"	CONST color=1.0,0.0,1.0,1.0;\n"
	"	\n"
	
	"[TECHNIQUE]	Model3\n"
	"[PASS0]\n"
	"	[POSITION]\n"
	"		tPos=iPos*4WORLD;\n"
	"       ldir=tPos - VECLIGHT;\n"
	"       dist.x=norme(ldir);\n"
	"		oPos=tPos*4VIEWPROJ;\n"
	"	[DIFFUSE]\n"
	"		value.x=dist.x*MULTI.x;\n"
	"		value.y=zero.x;\n"
	"		value.z=zero.x;\n"
	"		value.w = one.x;\n"
	"		oDiffuse = value;\n"
	
	"   [SHADER] \n"
	"		Out = Diffuse;\n"
	
	"	[RENDER_STATE]\n"
	"		ShadeMode				Smooth\n"
	"		ZBuffer					True\n"
	"		TextureCoordinate[0]	TexCoo0\n"
	
	"[END]\n"
	"\n";
	

	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	p.Init(0,0,0);

	Render.Distance=512;
	/////////////////////////////////////////////////////////////////////
	// textures	

	TimeInit();

	READ_PNG("data/explo.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/skull.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];
	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	

	float MULTI=1.0f/50.0f;

	CVertexBuffer *vbgrid;
	CObject3D grid;

	grid.Grid(50.0f,50.0f,16);
	grid.InverseOrientation();

	for (n=0;n<grid.nFaces;n++)
	{
		grid.Faces[n].nT=1;
		grid.Faces[n].nT2=grid.Faces[n].nT+VALUE_FINDING_BUMP_MAP;
	}
	vbgrid=Render.CreateMultiGroupFrom(&grid,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX|API3D_TEXTURE_NT2);

	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	rx=ry=rz=0.0f;

	rx=1.0f;

	CVertexBuffer effect;
	effect.BasicEffect();
	effect.SetVertexProgram(script_zbuffer);

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float values[6][4]={
		{ -3.147f,-0.143f,35.0f,0.0f },
		{ -3.147f,-0.143f,25.0f,5.2f },
		{ -3.147f,-0.143f,25.0f,8.2f },
		{ -3.397f,-0.143f,25.0f,10.2f },
		{ -2.797f,-0.143f,25.0f,11.2f },
		{ -3.347f,-0.007f,22.0f,12.85f } };


	float tt=0.0f;

	int deltat=TimeGet();
	int ms=3000-deltat*20;
	if (ms>0) Sleep(ms);
	else tt+=(-ms/20.0f)*0.007f;

	DrawImageFadeOut();


	InitFade();

	TimeInit();

	while (tt<5)
	{

		if (tt<0.5f) INCREMENT_FADE=1.0f;
		if (tt>4.5f) INCREMENT_FADE=-1.0f;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;

				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;

				float t=tt-(int) tt;
				if (t<0) t=0.0f;
				int zz=(int) tt;
				a1=values[zz][0] + t*(values[zz+1][0] - values[zz][0]);
				a2=values[zz][1] + t*(values[zz+1][1] - values[zz][1]);
				Zoom=values[zz][2] + t*(values[zz+1][2] - values[zz][2]);

				rx=2.2f;

				p.Init(25*sin(rx),-15,25*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				float rolling=45*sin(tt);

				MView.Id();
				MView.View(Camera,(Target-Camera),rolling);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				effect.setFloat("MULTI",MULTI);

				Render.Distance=384/2;
				Render.SetParams(API3D_RENDERTARGET,SECONDARY3);
				Render.ClearZBuffer();
				Render.SetProjection();
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetParams(API3D_BLEND,OFF);
				Render.SetTexture(2001);
				Render.Quad(0,0,Render.GetWidth(),Render.GetHeight(),0,0,1,1,1,0,0);

				Render.SetParams(API3D_ZBUFFER,ON);

				M.Id();
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				CMatrix MM;
				MM.View(Render.Lights[0].Pos,pos-Render.Lights[0].Pos,0);
				Render.LoadViewMatrix(MM);

				effect.setMatrixViewProj("VIEWPROJ");
				effect.setMatrix("WORLD",M);
				effect.setVector("VECLIGHT",Render.Lights[0].Pos);

				effectbump.setMatrixViewProj("VIEWPROJLIGHT");
				effectbump.setMatrix("VIEWPORTLIGHT",Render.VIEWPORT);

				Render.SetEffect(&effect);

				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				
				Render.SetEffect(NULL);
				Render.Distance=2050*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				
				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);

				InitGlow();

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetTexture(1200);
				Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,0.2f,0.2f,0.2f);
				Render.SetParams(API3D_ZBUFFER,ON);

				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);

				Render.SetParams(API3D_ZBUFFER,ON);

				CMatrix M;

				M.Id();
				
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				Render.SetTexture2(2002);
				Render.SetTexture(SECONDARYTEXTURE3);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_1);
				effectbump.setTextureAssociation("Shd",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
	
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Render.Lights[0].Pos);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				
				Render.SetEffect(NULL);
		
				M.Id();
				Render.LoadWorldMatrix(MM);
				Render.SetTexture(2002);
				Render.SetVertexBuffer(&vbsph);
				Render.DrawVertexBuffer();

				//////////////////////////////////////////////////////////////////////

				GlowRender(5,0.25f,1.2f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
				dt=TimeGet();

				tt=tt+dt*(1.0f/145.0f);

				Fade(dt*4);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
		
	}
		
_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);

	effect.Release();
	effectbump.Release();

	vb->Release();
	delete vb;
	vbgrid->Release();
	grid.Free();
	sph.Free();
	vbsph.Release();

	Scene.Clean();

	return res;

}


CObject3D **tabobj;
int *tabobjs;
int p=0;
int nb=0;

float function(int N,float cx,float cy,float cz)
{
	float constx=-0.78f;
	float consty=0.05f;
	float constz=0.17f;
	register float x=cx;
	register float y=cy;
	register float z=cz;
	float pi=3.14159265f;
	float pi2=pi/2;
	int it=0;
	int n=1;
	register float r,rr;
	register float yang;
	register float zang;

	while ((x*x + y*y + z*z  <  2.0)&&(it<N))
	{
		r    = sqrtf(x*x + y*y + z*z );
		yang = 2*atan2f(sqrt(x*x + y*y) , z  )  ;
		zang = 2*atan2f(y , x);
		rr=r*r;
		x = (rr) * sinf( yang + pi2 ) * cosf(zang +pi);
		y = (rr) * sinf( yang + pi2 ) * sinf(zang +pi);
		z = (rr) * cosf( yang + pi2 );
		x +=constx;
		y +=consty;
		z +=constz;
		it++;
	}
	
	if (it<N) return 10.0f;
	return 0.0f;
}

#include "surfaces.h"

void InitMandel()
{
	int n,x,y,z;
	int NB_CUBES=2;

	while (!Render.BEGIN()) Sleep(1);
	Render.ClearVideoAndZBuffer();
	Render.SetTexture(4);
	Render.Quad(0,Render.SCREEN_Y/2-20,Render.SCREEN_X,40,0,0,1,1,1,1,1);
	Render.Quad(1,Render.SCREEN_Y/2-19,Render.SCREEN_X-2,38,0,0,1,1,0,0,0);
	Render.END();
	Render.FlipDoubleBuffer();

	tabobjs=new int[2];
	tabobj=(CObject3D**) malloc(2);

	CSurfaces *surf=new CSurfaces;

	nb=0;

	p=0;
	int nb=0;

	x=0;
	y=0;
	for (z=0;z<NB_CUBES;z++)
	{
				
		surf->Init("");
				
		surf->DIVISION=0.2f/10;
		surf->SetEquipotentielle(1,0.0001f);
		int minx=-1.5f/surf->DIVISION;
		int miny=-1.5f/surf->DIVISION;
		int minz=-1.5f/surf->DIVISION;

		int maxx=1.5f/surf->DIVISION;
		int maxy=1.5f/surf->DIVISION;
		int maxz=1.5f/surf->DIVISION;

		surf->Calculate(
		0, 
		minx+(x*(maxx-minx))/NB_CUBES,
		miny+(y*(maxy-miny))/NB_CUBES,
		minz+(z*(maxz-minz))/NB_CUBES,

		minx+((x+1)*(maxx-minx))/NB_CUBES,
		miny+((y+1)*(maxy-miny))/NB_CUBES,
		minz+((z+1)*(maxz-minz))/NB_CUBES
		);

		if (surf->OBJ.nVertices>0)
		{
			tabobj[nb]=surf->OBJ.Duplicate2();

			tabobj[nb]->CalculateNormals(-1);
			tabobj[nb]->SphericalMapping();

			for (n=0;n<tabobj[nb]->nVertices;n++) tabobj[nb]->Vertices[n].Stok*=12;

			for (n=0;n<tabobj[nb]->nFaces;n++) tabobj[nb]->Faces[n].nT=0;
			for (n=0;n<tabobj[nb]->nFaces;n++) tabobj[nb]->Faces[n].nT2=VALUE_FINDING_BUMP_MAP;
			tabobjs[nb]=1;
			surf->OBJ.Free();
		}
		else tabobjs[nb]=0;

		p++;

		nb++;

		float pc=(float)p/((NB_CUBES/2)*(NB_CUBES/2)*NB_CUBES);
		Render.BEGIN();
		Render.ClearVideoAndZBuffer();
		Render.SetTexture(4);
		Render.Quad(0,Render.SCREEN_Y/2-20,Render.SCREEN_X,40,0,0,1,1,1,1,1);
		Render.Quad(1,Render.SCREEN_Y/2-19,Render.SCREEN_X-2,38,0,0,1,1,0,0,0);
		Render.Quad(1,Render.SCREEN_Y/2-19,0.7f*pc*Render.SCREEN_X-2,38,0,0,1,1,1,1,1);
		Render.END();
		Render.FlipDoubleBuffer();

	}
}



bool Mandel(int EFFECT_DT)
{
	bool res=true;

char * script_envmap_bump =
"[VERTEXFORMAT]\n"
"	XYZ NORMAL TEX0\n"
"[DEFINES]\n"
"	MATRIX WORLD;\n"
"	MATRIX VIEWPROJ;\n"
"	VECTOR VECLIGHT;\n"
"	VECTOR LIGHTPOS;\n"
"	VECTOR CAMERA;\n"
"	VECTOR AMBIENT;\n"
"	VECTOR MULTI;\n"
"	CONST zero;\n"
"	CONST one=1.0,1.0,1.0,1.0;\n"
"	CONST med=0.5,0.3;\n"
"	TEXTURE Tex;\n"
"	TEXTURE Shd;\n"
"	TEXTURE Bump;\n"
"	TEXTURE Env;\n"
"	PSCONST psone=0.2,0.2,0.8,1.0;\n"
"	PSCONST psamb=0.15,0.15,0.15,1.0;\n"
"	CONST scale=0.0009765625,0.5;\n"
"	CONST cst=0.1,0.1,0.1;\n"
"	\n"

"[TECHNIQUE]	Model3\n"
"[PASS0]\n"
"	[POSITION]\n"
"		tPos=iPos*4WORLD;\n"
"		tNorm=iNorm*3WORLD;\n"
"       ldir=tPos - CAMERA;\n"
"       ldir=normalise(ldir);\n"
"       N=tNorm + tNorm + ldir;\n"
"       N=normalise(N);\n"
"       ripoux=(tNorm|VECLIGHT);\n"
"		oPos=tPos*4VIEWPROJ;\n"

"	[DIFFUSE]\n"
"		oDiffuse=AMBIENT - min(ripoux,zero);\n"
"	[MAPPING0]\n"
"		oTexture0.x=iTexture0.x;\n"
"		oTexture0.y=iTexture0.y;\n"
"	[MAPPING1]\n"
"		oTexture1.x=med.x-med.x*N.x;\n"
"		oTexture1.y=med.x+med.x*N.y;\n"

"   [SHADER] \n"
"		Out = sample(0,Tex0);\n"
"		val1 = sample(1,Tex1);\n"
"       val4 = Diffuse;\n"
"		val1.a = psone.a;\n"
"		Out.rgb = Out.rgb + val1.rgb;\n"
"		Out.rgb = Out.rgb * val4.rgb;\n"


"	[RENDER_STATE]\n"

"		ShadeMode				Smooth\n"
"		Texture[0]				Tex\n"
"		Texture[1]				Env\n"
"		Texture[2]				Bump\n"
"		Texture[3]				Shd\n"
"		ZBuffer					True\n"
"		TextureCoordinate[0]	TexCoo0\n"
"		Mip[0]					Linear\n"
"		Mip[1]					Linear\n"
"		Mip[2]					Linear\n"
"		Mag[0]					Linear\n"
"		Mag[1]					Linear\n"
"		Mag[2]					Linear\n"
"		Min[0]					Linear\n"
"		Min[1]					Linear\n"
"		Min[2]					Linear\n"

"[END]\n"
"\n";


	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;

	TimeInit();

	p.Init(0,0,0);

	Render.Distance=512;
	/////////////////////////////////////////////////////////////////////
	// textures	

	TimeInit();

	READ_PNG("data/explo.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	READ_PNG("data/mandel.png",&im,ALPHA1);
	Render.CreateTexture(0,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;


	CVertexBuffer * vb0=Render.CreateMultiGroupFrom(tabobj[0],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	CVertexBuffer * vb1=Render.CreateMultiGroupFrom(tabobj[1],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	tabobj[0]->InverseOrientation();
	tabobj[1]->InverseOrientation();
	for (n=0;n<tabobj[0]->nVertices;n++) tabobj[0]->Vertices[n].Norm=-1*tabobj[0]->Vertices[n].Norm;
	for (n=0;n<tabobj[1]->nVertices;n++) tabobj[1]->Vertices[n].Norm=-1*tabobj[1]->Vertices[n].Norm;
	CVertexBuffer * vb0a=Render.CreateMultiGroupFrom(tabobj[0],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	CVertexBuffer * vb1a=Render.CreateMultiGroupFrom(tabobj[1],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	

	for (n=0;n<tabobj[0]->nVertices;n++) tabobj[0]->Vertices[n].Stok*=0.2f;
	for (n=0;n<tabobj[1]->nVertices;n++) tabobj[1]->Vertices[n].Stok*=0.2f;

	for (n=0;n<tabobj[0]->nVertices;n++) tabobj[0]->Vertices[n].Stok.z=-tabobj[0]->Vertices[n].Stok.z;
	for (n=0;n<tabobj[1]->nVertices;n++) tabobj[1]->Vertices[n].Stok.z=-tabobj[1]->Vertices[n].Stok.z;

	for (n=0;n<tabobj[0]->nVertices;n++) tabobj[0]->Vertices[n].Norm.z=-tabobj[0]->Vertices[n].Norm.z;
	for (n=0;n<tabobj[1]->nVertices;n++) tabobj[1]->Vertices[n].Norm.z=-tabobj[1]->Vertices[n].Norm.z;

	CVertexBuffer * _vb0=Render.CreateMultiGroupFrom(tabobj[0],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	CVertexBuffer * _vb1=Render.CreateMultiGroupFrom(tabobj[1],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	tabobj[0]->InverseOrientation();
	tabobj[1]->InverseOrientation();
	for (n=0;n<tabobj[0]->nVertices;n++) tabobj[0]->Vertices[n].Norm=-1*tabobj[0]->Vertices[n].Norm;
	for (n=0;n<tabobj[1]->nVertices;n++) tabobj[1]->Vertices[n].Norm=-1*tabobj[1]->Vertices[n].Norm;
	CVertexBuffer * _vb0a=Render.CreateMultiGroupFrom(tabobj[0],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	CVertexBuffer * _vb1a=Render.CreateMultiGroupFrom(tabobj[1],API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	


	float MULTI=1.0f/50.0f;
	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	rx=ry=rz=0.0f;

	rx=1.0f;

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	Zoom=35.0f;
	a1=-3.147f;
	a2=-0.143f;

	float values[13][4]={
		{ -3.147f,-0.143f,35.0f,0.0f },
		{ -3.147f,0.507f,30.0f,0.0f },
		{ -2.597f,0.507f,24.0f,0.0f },
		{ -2.147f,0.357f,9.9f,0.0f },
		{ -2.047f,-0.143f,3.5f,0.0f },
		{ 0.803f,-0.143f,4.0f,0.0f },
		{ -2.047f,-0.143f,4.0f,0.0f },
		{ -4.797f,0.507f,4.5f,0.0f },
		{ -3.697f,0.507f,18.5f,0.0f },
		{ -3.397f,-0.443f,28.5f,0.0f },
		{ -1.647f,-0.443f,28.5f,0.0f },
		{ 2.647f,0.443f,35.0f,0.0f },
		{ -1.647f,-0.443f,28.5f,0.0f }
	
	};


	float tt=0.0f;

	
	int deltat=TimeGet();
	int ms=500-deltat*20;
	if (ms>0) Sleep(ms);
	else tt+=0.0095f*(-ms/20.0f);

	InitFade();

	TimeInit();

	while (tt<12)
	{
		
		if (tt<0.5f) INCREMENT_FADE=1.0f;
		if (tt>11.5f) INCREMENT_FADE=-1.0f;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;

				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.5f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.5f;
				
				float t=tt-(int) tt;
				int zz=(int) tt;
				a1=values[zz][0] + t*(values[zz+1][0] - values[zz][0]);
				a2=values[zz][1] + t*(values[zz+1][1] - values[zz][1]);
				Zoom=values[zz][2] + t*(values[zz+1][2] - values[zz][2]);
				rx=values[zz][3] + t*(values[zz+1][3] - values[zz][3]);
				/**/
				CVector C;
				C.x=(float) (sin(values[0][0])*cos(values[0][1])*values[0][2]);
				C.y=(float) (sin(values[0][1])*values[0][2]);
				C.z=(float) (cos(values[0][0])*cos(values[0][1])*values[0][2]);

				p.Init(C.x+10+10*sin(rx),C.y-10,C.z+10*cos(rx));
				Render.SetLightPoint(0,p,1,1,1,0.01f,50);

				Camera.x=(float) (sin(a1)*cos(a2)*Zoom);
				Camera.y=(float) (sin(a2)*Zoom);
				Camera.z=(float) (cos(a1)*cos(a2)*Zoom);

				Target.x=0;
				Target.y=0;
				Target.z=0;

				float rolling=0*45*sin(tt);

				MView.Id();
				MView.View(Camera,(Target-Camera),rolling);

				/////////////////////////////////////////////////////////////////////

				CVector pos;

				effectbump.setFloat("MULTI",MULTI);
				
				Render.Distance=2050;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);

				Render.SetParams(API3D_ZBIAS,0);

				
				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

				InitGlow();

                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);

                Render.SetParams(API3D_ZBUFFER,OFF);
				Render.SetTexture(1200);
				Render.Quad(0,0,Render.SCREEN_X,Render.SCREEN_Y,0,0,1,1,0.2f,0.2f,0.2f);
				Render.SetParams(API3D_ZBUFFER,ON);

				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);

				Render.SetParams(API3D_ZBUFFER,ON);

				CMatrix M;

				M.Id();
				
				pos.Init(M.a[3][0],M.a[3][1],M.a[3][2]);

				Render.SetTexture2(2002);
				Render.SetTexture(SECONDARYTEXTURE4);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_1);
				effectbump.setTextureAssociation("Shd",TEXTURE_FROM_RENDER_0);

				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
	
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Camera);

				Render.SetEffect(&effectbump);

			
				M.Id();
				M.Scaling(1,1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vb0);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(vb1);
				Render.DrawVertexBuffer();

				M.Id();
				M.Scaling(-1,1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vb0a);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(vb1a);
				Render.DrawVertexBuffer();


				M.Id();
				M.Scaling(-1,-1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vb0);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(vb1);
				Render.DrawVertexBuffer();

				M.Id();
				M.Scaling(1,-1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vb0a);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(vb1a);
				Render.DrawVertexBuffer();

				//mini

				M.Id();
				M.Scaling(1,1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(_vb0);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(_vb1);
				Render.DrawVertexBuffer();

				M.Id();
				M.Scaling(-1,1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(_vb0a);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(_vb1a);
				Render.DrawVertexBuffer();


				M.Id();
				M.Scaling(-1,-1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(_vb0);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(_vb1);
				Render.DrawVertexBuffer();

				M.Id();
				M.Scaling(1,-1,1);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(_vb0a);
				Render.DrawVertexBuffer();
				Render.SetVertexBuffer(_vb1a);
				Render.DrawVertexBuffer();
			
				Render.SetEffect(NULL);
		
				M.Id();
				M.Rotation(rx/4,rx,rx/4);
				Render.LoadWorldMatrix(M);
				Render.SetTexture(2002);
				Render.SetVertexBuffer(&vbsph);
				Render.DrawVertexBuffer();
				
                //////////////////////////////////////////////////////////////////////

				GlowRenderaa(5,0.25f,1.2f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
                //BordsNoirs();
				dt=TimeGet();

				tt=tt+dt*(1.0f/115.0f); //114

				Fade(dt*4);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
		
	}

_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);
	Render.FreeTexture(0);
	
	vb0->Release();
	vb1->Release();
	vb0a->Release();
	vb1a->Release();
	_vb0->Release();
	_vb1->Release();
	_vb0a->Release();
	_vb1a->Release();

	delete vb0;
	delete vb1;
	delete vb0a;
	delete vb1a;
	delete _vb0;
	delete _vb1;
	delete _vb0a;
	delete _vb1a;

	vbsph.Release();
	sph.Free();

	effectbump.Release();

    return res;

}


bool Wormhole(int EFFECT_DT)
{
	bool res=true;

char * script_envmap_bump =
"[VERTEXFORMAT]\n"
"	XYZ NORMAL TEX0\n"
"[DEFINES]\n"
"	MATRIX WORLD;\n"
"	MATRIX VIEWPROJ;\n"
"	VECTOR VECLIGHT;\n"
"	VECTOR LIGHTPOS;\n"
"	VECTOR CAMERA;\n"
"	VECTOR AMBIENT;\n"

"	CONST zero;\n"
"	CONST one=1.0,1.0,1.0,1.0;\n"
"	CONST four=4.0,4.0,4.0,1.0;\n"
"	CONST med=0.5,0.3;\n"
"	TEXTURE Tex;\n"
"	TEXTURE Bump;\n"
"	TEXTURE Env;\n"
"	PSCONST psone=0.1,0.1,0.8,1.0;\n"
"	CONST scale=0.0009765625,0.5;\n"
"	CONST cst=0.1,0.1,0.1;\n"
"	\n"

"[TECHNIQUE]	Model3\n"
"[PASS0]\n"
"	[POSITION]\n"
"		tPos=iPos*4WORLD;\n"
"		tNorm=iNorm*3WORLD;\n"
"       ldir=tPos - CAMERA;\n"
"       ldir=normalise(ldir);\n"
"       N=tNorm + tNorm + ldir;\n"
"       N=normalise(N);\n"
"       ripoux.x=(tNorm|VECLIGHT);\n"
"		oPos=tPos*4VIEWPROJ;\n"

"	[DIFFUSE]\n"
"		oDiffuse.x=AMBIENT.x - min(ripoux.x,zero.x);\n"
"		oDiffuse.y=AMBIENT.x - min(ripoux.x,zero.x);\n"
"		oDiffuse.z=AMBIENT.x - min(ripoux.x,zero.x);\n"
"		oDiffuse.w=one.x;\n"

"	[MAPPING0]\n"
"		oTexture0.x=iTexture0.x;\n"
"		oTexture0.y=iTexture0.y;\n"
"	[MAPPING1]\n"
"		oTexture1.x=med.x-med.x*N.x;\n"
"		oTexture1.y=med.x+med.x*N.y;\n"

"   [SHADER] \n"
"		val1 = coord(Tex1);\n"
"		val2 = sample(2,Tex0);\n"	
"		val1.ba = psone.aa;\n"			
"		val2 = psone * val2;\n"
"		val2 = val1 + val2;\n"
"		Out = sample(0,Tex0);\n"
"		val1 = sample(1,val2);\n"
"       val4 = Diffuse;\n"
"		Out = Out + val1;\n"
"		Out = Out * val4;\n"


"	[RENDER_STATE]\n"

"		ShadeMode				Smooth\n"
"		Texture[0]				Tex\n"
"		Texture[1]				Env\n"
"		Texture[2]				Bump\n"
"		ZBuffer					True\n"
"		TextureCoordinate[0]	TexCoo0\n"
"		Mip[0]					Linear\n"
"		Mip[1]					Linear\n"
"		Mip[2]					Linear\n"
"		Mag[0]					Linear\n"
"		Mag[1]					Linear\n"
"		Mag[2]					Linear\n"
"		Min[0]					Linear\n"
"		Min[1]					Linear\n"
"		Min[2]					Linear\n"

"[END]\n"
"\n";


	float TIMESPENT=0.0f;
	CVector Camera,Target;
	int EXIT=0;
	CMatrix M,M1,M2,MView;
	struct IMAGE_DATAS im;
	float Zoom=10.5f;
	float a1=-PI/3;
	float a2=-PI/8;
	float dt;
	float rx,ry,rz;
	int n,k;
	CVector p;


	p.Init(0,0,0);

	Render.Distance=512;
	/////////////////////////////////////////////////////////////////////
	// textures	

	TimeInit();

	READ_PNG("data/wormhole.png",&im,ALPHA1);
	Render.CreateTexture(2002,im.X,im.Y,im.ptrImageDATAS,im.X,im.Y,NO_ALPHA);
	free(im.ptrImageDATAS);

	/////////////////////////////////////////////////////////////////////

	Init_WorldUp(0,-1,0);

	/////////////////////////////////////////////////////////////////////
	float counter=0.0f;
	dt=1.0f;

	Scene.REALTIME_ANIMATED=0;
	Scene.Load("data/wormhole.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);

	CObject3D * obj=Scene.WorldObjects[0];

	for (n=0;n<obj->nFaces;n++)
	{
		obj->Faces[n].nT2=obj->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}
	
	CVertexBuffer * vb=Render.CreateMultiGroupFrom(obj,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	
	CObject3D * obj2=Scene.WorldObjects[1];

	for (n=0;n<obj2->nFaces;n++)
	{
		obj2->Faces[n].nT2=obj2->Faces[n].nT+VALUE_FINDING_BUMP_MAP;	
	}

	CVertexBuffer * vb2=Render.CreateMultiGroupFrom(obj2,API3D_VERTEXDATAS|API3D_NORMALDATAS|API3D_TEXPERVERTEX|API3D_TEXCOODATAS|API3D_TEXTURE_NT2);	
	

	float MULTI=1.0f/50.0f;
	
	CVertexBuffer vbsph;
	CObject3D sph;

	sph.OpenSphere2(500.0f,32,0);
	vbsph.CreateFrom2(&sph,API3D_VERTEXDATAS|API3D_COLORDATAS|API3D_TEXCOODATAS|API3D_TEXPERVERTEX);
	rx=ry=rz=0.0f;

	rx=1.0f;

	CVertexBuffer effectbump;
	effectbump.BasicEffect();
	effectbump.SetVertexProgram(script_envmap_bump);

	float tt=0.0f;
	
	int deltat=TimeGet();
	int ms=3000-deltat*20;
	if (ms>0) Sleep(ms);
	else tt+=(-ms/20.0f)*0.1f;

	fade_start=0;
	fade_end=0;
	DrawImageFadeOut();

	

	InitFade();
	fade_end=1;

	TimeInit();

	while (tt<Scene.anim->nb_frames-8)
	{
		//if (TIMESPENT>EFFECT_DT-32) INCREMENT_FADE=-1;

		if (tt<0.5f) INCREMENT_FADE=1.0f;
		if (tt>Scene.anim->nb_frames-16.0f) INCREMENT_FADE=-1.0f;

		if (!ReadEvents()) EXIT=1;
		else
		{
			if (Render.BEGIN())
			{
				/////////////////////////////////////////////////////////////////////
				if (TabKeys[KEY_ESCAPE]) goto _abort;
				if (TabKeys[KEY_SPACE]) goto _skip;

				if (TabKeys[KEY_UP]) a2+=0.05f;
				if (TabKeys[KEY_DOWN]) a2-=0.05f;
				if (TabKeys[KEY_RIGHT]) a1+=0.05f;
				if (TabKeys[KEY_LEFT]) a1-=0.05f;

				if (TabKeys['A']) rx+=0.15f;
				if (TabKeys['Z']) rx-=0.15f;
				if (TabKeys['Q']) ry+=1.5f;
				if (TabKeys['S']) ry-=1.5f;
				if (TabKeys['W']) rz+=1.5f;
				if (TabKeys['X']) rz-=1.5f;

				if (TabKeys[KEY_PAGEUP]) Zoom-=0.1f;
				if (TabKeys[KEY_PAGEDOWN]) Zoom+=0.1f;
				
				float t=tt-(int) tt;
				int zz=(int) tt;			

				int k1=zz;
				int k2=(zz+1)%Scene.anim->nb_frames;

				CVector p1,p2;

				p1=Scene.anim->array_camera[k1]; p2=Scene.anim->array_camera[k2];
				Camera=p1 + t*(p2-p1);
	

				p1=Scene.anim->array_target[k1]; p2=Scene.anim->array_target[k2];
				Target=p1 + t*(p2-p1);
		
				CVector u;
				u=Target-Camera;
				u.Normalise();
				Target=Camera + u;


				Render.SetLightPoint(0,Camera,1,1,1,0.01f,50);

				float rolling=tt*14;

				MView.Id();
				MView.View(Camera,(Target-Camera),rolling);

				/////////////////////////////////////////////////////////////////////

				CVector pos;
				
				
				Render.Distance=1024*Render.SCREEN_X/1920.0f;
				Render.SetParams(API3D_RENDERTARGET,PRIMARY);
				
				Render.SetParams(API3D_ZBIAS,0);
				
				Render.ClearVideoAndZBuffer();
				Render.SetProjection();
				Render.LoadViewMatrix(MView);
				
				Render.SetParams(API3D_CULL,ON);
				Render.SetParams(API3D_CULL,CCW);
				
				InitGlow();
				Render.LoadViewMatrix(MView);
				Render.SetParams(API3D_ZBUFFER,OFF);
				
                Render.SetParams(API3D_CULL,ON);
                Render.SetParams(API3D_CULL,CCW);
				Render.SetParams(API3D_ZBUFFER,ON);
				
				CMatrix M;
				
				M.Id();
				M.Translation(obj->Coo.x,obj->Coo.y,obj->Coo.z);
				pos=Target;

				Render.SetTexture(2002);

				effectbump.resetAssignation();
				effectbump.setTextureAssociation("Tex",TEXTURE_FROM_NT);
				effectbump.setTextureAssociation("Bump",TEXTURE_FROM_NT2);
				effectbump.setTextureAssociation("Env",TEXTURE_FROM_RENDER_0);


				effectbump.setMatrixViewProj("VIEWPROJ");
				effectbump.setMatrix("WORLD",M);				
				effectbump.setFloat("AMBIENT",0.1f);

				effectbump.setVector("LIGHTPOS",Render.Lights[0].Pos);
	
				CVector light=pos- Render.Lights[0].Pos;				
				light.Normalise();
				effectbump.setVector("VECLIGHT",light);
				effectbump.setVector("CAMERA",Camera);

				Render.SetEffect(&effectbump);
				Render.SetVertexBuffer(vb);
				Render.DrawVertexBuffer();
				
				M.Id();
				M.RotationDegre(rx,ry,rz);
				u=Target-Camera;
				u.Normalise();
				u=Target+3*u;

				M.Translation(u.x,u.y,u.z);
				effectbump.setMatrix("WORLD",M);
				Render.SetVertexBuffer(vb2);
				Render.DrawVertexBuffer();
			
				Render.SetEffect(NULL);
		
			   //////////////////////////////////////////////////////////////////////

				GlowRenderaa(7,0.01f,1.0f);

				Render.SetParams(API3D_BLEND,OFF);
				Render.SetParams(API3D_ZBUFFER,ON);


				Render.SetParams(API3D_RENDERTARGET,RENDER);
                
				dt=TimeGet();

				tt=tt+dt*(1.0f/15.0f);
		

				Fade(dt*4);
				/////////////////////////////////////////////////////////////////////
				Render.END();
				Render.FlipDoubleBuffer();
			}

			/////////////////////////////////////////////////////////////////////
		}
		TIMESPENT+=dt;
		
		rx+=0.5f*dt;
		ry+=dt;
		rz+=1.5f*dt;/**/
	}

_skip:
    res=true;
	goto _free;
_abort:
    res=false;
_free:

	TabKeys[KEY_ESCAPE]=0;
	TabKeys[KEY_SPACE]=0;

	Render.FreeTexture(2002);

	vb->Release();
	delete vb;
	sph.Free();
	vbsph.Release();

	Scene.Clean();

	return res;

}

//////////////////////////////////////////////////////////////////////////////////////////////////////
extern bool windowed;
extern int WX;
extern int WY;
float SCREEN_RATIO=1.0f;
//////////////////////////////////////////////////////////////////////////////////////////////////////
void GAMES_PROGRAMME_PRINCIPAL()
{

	Render.Distance=768;
	Render.SetParams(API3D_CREATETEXTURE,MIPMAP);
	Render.SetParams(API3D_HARDWAREVERTEXPROCESSING,ON);

	Render.SetParams(API3D_SECONDARYSURFACE,SECONDARY5);  // 3 chevy
	Render.TILE_SecondarySurface=512;
	Render.SetTileSecondary(SECONDARY1,1024);
	Render.SetTileSecondary(SECONDARY2,1024);
	Render.SetTileSecondary(SECONDARY3,1024);
	Render.SetTileSecondary(SECONDARY4,1024);
	Render.SetTileSecondary(SECONDARY5,1024);
#ifdef WIN32	
	Render.SetHandleInstance(hInstance);
	Render.SetHandleWindow(hWnd);
#endif	
	Render.StencilBuffer=true;
	Render.SetParams(API3D_MISC,VBL_SYNCHRO);
	if (Render.InitVideoWindowed(WX,WY,RGB32BITS)<=0) return;
	
	if (!Render.SecondarySurface) return;

	Render.SetParams(API3D_SHADERS,FIXED_ENV);
	Render.SetParams(API3D_ENVMULTIGROUP,INTERN);

	Render.InitViewport();
	Render.SetScreenRatio(SCREEN_RATIO);
	Render.Distance=(768*Render.SCREEN_X)/1024.0f;

	scalex=Render.SCREEN_X/1024.0f;
	scaley=Render.SCREEN_Y/768.0f;

	Render.Front=0.01f;
	Render.Back=5000;
	Init_WorldUp(0,-1,0);

	Initialise();

#ifdef WIN32	
	InitSound(hWnd);
#else
	InitSound();
#endif
	
	Render.SetParams(API3D_ZBUFFER,OFF);
	Render.SetParams(API3D_CULL,ON);
	Render.SetParams(API3D_CULL,CCW);

    InitMandel();

    Scene.REALTIME_ANIMATED=0;
    Scene.Load("data/stars.ned",DONT_FREE_RESSOURCE_FOR_REALTIME);
    OBJECT_STARS=Scene.WorldObjects[0]->Duplicate2();
    Scene.Clean();

	InitMonarchDebut();

	Render.BEGIN();
	Render.ClearVideoAndZBuffer();
	Render.SetTexture(4);
	Render.Quad(0,Render.SCREEN_Y/2-20,Render.SCREEN_X,40,0,0,1,1,1,1,1);
	Render.Quad(1,Render.SCREEN_Y/2-19,Render.SCREEN_X-2,38,0,0,1,1,0,0,0);
	Render.Quad(1,Render.SCREEN_Y/2-19,Render.SCREEN_X-2,38,0,0,1,1,1,1,1);
	Render.END();
	Render.FlipDoubleBuffer();

	OGG_Play("data/beliefs in Fortran.ogg",0);
	
	if (!DrawImageFadeIn("data/present.png")) goto _abort;
	Sleep(4000);
	DrawImageFadeOut();
	if (!MonarchDebut(300,2,"data/prelude1.png")) goto _abort;
	if (!MonarchDebut(350,1,"data/prelude2.png")) goto _abort;
	if (!MonarchDebut(400,3,"data/prelude3.png")) goto _abort;
	Sleep(500);
	if (!DrawImage("data/code.png")) goto _abort;
	if (!DrawImage("data/art.png")) goto _abort;
	if (!DrawImage("data/music.png")) goto _abort;
	if (!Chevy(500)) goto _abort;
	if (!DrawImageFadeIn("data/logo.png")) goto _abort;
	if (!Stars(1250+100)) goto _abort;
	if (!DrawImageFadeIn("data/nooon.png"))  goto _abort;
	if (!Meuf(500)) goto _abort;
	if (!DrawImageFadeIn("data/elephant.png"))  goto _abort;
	if (!Skull(500)) goto _abort;
	if (!Mandel(500)) goto _abort;
	if (!DrawImageFadeIn("data/fish.png"))  goto _abort;
	if (!Wormhole(500)) goto _abort;
	if (!FoetusCaustic(500)) goto _abort;
	if (!Monarch(500,0,"data/end1.png")) goto _abort;
	if (!Monarch(500,1,"data/end2.png")) goto _abort;
	Sleep(3500);
	if (!DrawImageFadeIn("data/endlogo.png")) goto _abort;
	Sleep(5000);
	DrawImageFadeOut();
	Sleep(4000);
	/////////////////////////////////////////////////////////////////////
_abort:
	Sleep(1);
}




