////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	  <3D Librairies developped during 2002-2008>
//	  Copyright (C) <2008>  <Laurent Canc Francis, 10/08/1975>
//	  laurentcance@free.fr
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////
int PLANK=5000;
//////////////////////////////////////////////////////////////////////////////////////////////////////
//	@file surfaces.cpp
//	@author Laurent Cance <laurentcance@free.fr>
//	@copyright 2010
//	@created 2002
//	@date 2010-03-28
//	$Author: laurent canc francis $
//	$Revision: XX $
//////////////////////////////////////////////////////////////////////////////////////////////////////

#include "surfaces.h"

#include <math.h>
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma warning (disable:4244)
#pragma warning (disable:4101)
#pragma warning (disable:4018)
#pragma warning (disable:4305)
#pragma warning (disable:4309)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdarg.h>
#include <stdio.h>
#include <io.h>
#include <direct.h>
#include <time.h>
#include <shlobj.h>
#include <windows.h>
#include <winuser.h>
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../lib3d/base/maths.h"
#include "../lib3d/base/objects3d.h"
#include "../lib3d/base/3d_api_base.h"
#include "../lib3d/base/3d_api.h"
#include "../lib3d/base/bsp_light.h"
#include "../lib3d/data/TLK3D_scene.h"
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "../ned/classned.h"
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern NED			Scene;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern int METABALLS_PERCENT;
extern int METABALLS_POTENTIEL;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define MARCHING_CUBES
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define K_SMALLF SMALLF2
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define K_ITERATIONS 4
#define DEPTH 0
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern float function(int N,float x,float y,float z);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSurfaces::SetEquipotentielle(float e,float precision)
{
	equi=e;
	small_float=precision*0.01f;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
float CSurfaces::Potentiel(int N,CVector *u)
{
	return function(20,u->x,u->y,u->z);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DELTA 0.00001f
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CVector CSurfaces::Gradiant(CVector *A)
{
	CVector u;
	u.Init(1,1,1);
	return u;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSurfaces::EquiPotentielle(int N,CVector *A,CVector *B,float pA,float pB)
{
	CVector I,a,b;
	float p1,p2,p;
	register int n;

	VECTORINIT(I,0,0,0);

	if (pA<0) p1=Potentiel(N,A);
	else p1=pA;

	if (pB<0) p2=Potentiel(N,B);
	else p2=pB;

	if (p1>=equi)
	{
		a=*A;
		b=*B;
	}
	else
	{
		a=*B;
		b=*A;
	}

	VECTORADD(I,a,b);
	VECTORMUL(I,I,0.5f);

	p=Potentiel(N,&I);
	n=0;
	while (n<K_ITERATIONS)
	{
		if (p<equi) b=I;
		else a=I;

		VECTORADD(I,a,b);
		VECTORMUL(I,I,0.5f);
		p=Potentiel(N,&I);
		n++;
	}

	if (p<equi) b=I;
	else a=I;
	VECTORADD(I,a,b);
	VECTORMUL(I,I,0.5f);

	return UploadVertices(&I);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CSurfaces::Init(char * function)
{
	pnc0[0]=0; pnc1[0]=0; pnc2[0]=0; pnc3[0]=0;
	pnc0[1]=0; pnc1[1]=0; pnc2[1]=1; pnc3[0]=1;
	pnc0[2]=0; pnc1[2]=1; pnc2[2]=0; pnc3[0]=2;
	pnc0[3]=0; pnc1[3]=1; pnc2[3]=1; pnc3[0]=3;
	pnc0[4]=1; pnc1[4]=0; pnc2[4]=0; pnc3[0]=4;
	pnc0[5]=1; pnc1[5]=0; pnc2[5]=1; pnc3[0]=5;
	pnc0[6]=1; pnc1[6]=1; pnc2[6]=0; pnc3[0]=6;
	pnc0[7]=1; pnc1[7]=1; pnc2[7]=1; pnc3[0]=7;

	segm0[ 0]=0; segm1[ 0]=1;
	segm0[ 1]=1; segm1[ 1]=3;
	segm0[ 2]=2; segm1[ 2]=3;
	segm0[ 3]=0; segm1[ 3]=2;
	segm0[ 4]=0; segm1[ 4]=4;
	segm0[ 5]=4; segm1[ 5]=6;
	segm0[ 6]=2; segm1[ 6]=6;
	segm0[ 7]=1; segm1[ 7]=5;
	segm0[ 8]=4; segm1[ 8]=5;
	segm0[ 9]=3; segm1[ 9]=7;
	segm0[10]=5; segm1[10]=7;
	segm0[11]=6; segm1[11]=7;

	if (!Vertices) Vertices=new CVector[1024*1024*2];
	if (!Faces[0]) Faces[0]=new int[1024*1024*2];
	if (!Faces[1]) Faces[1]=new int[1024*1024*2];
	if (!Faces[2]) Faces[2]=new int[1024*1024*2];

	Orientation=1;
	nVertices=0;
	nFaces=0;
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSurfaces::CalculateIntersectionSegment(int N,int l,int m,int n,int n0,int n1)
{
	int I;

	if (Segments[n0][n1]==-1)
	{
		I=EquiPotentielle(N,&pts[n0],&pts[n1],e[n0],e[n1]);
		Segments[n0][n1]=I;
		Segments[n1][n0]=I;
	}
	else
	{
		I=Segments[n0][n1];
	}

	return I;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSurfaces::UploadVertices(CVector *A)
{
	CVector u;
	int nn=nVertices;
	nn-=PLANK;
	if (nn>0)
	{
		for (register int n=nn;n<nVertices;n++)
		{
			u.x=Vertices[n].x - A->x;
			u.y=Vertices[n].y - A->y;
			u.z=Vertices[n].z - A->z;
			
			if (VECTORNORM2(u)<SMALLF) return n;
		}
	}
	Vertices[nVertices++]=(*A);
	return nVertices-1;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSurfaces::UploadTriangle(int ref,int A,int B,int C)
{
	int sens;

	sens=0;
	if (e[ref]<equi) sens=1;
	if (impair==1) sens=(sens+1)&1;

	if (sens==Orientation)
	{
		Faces[0][nFaces]=A;
		Faces[1][nFaces]=B;
		Faces[2][nFaces]=C;
	}
	else
	{
		Faces[0][nFaces]=A;
		Faces[1][nFaces]=C;
		Faces[2][nFaces]=B;
	}
	nFaces++;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSurfaces::CalcTetrahedron(int N,int l,int m,int n,int n0,int n1,int n2,int n3)
{
	int e01,e02,e03,e00;
	int e12,e23,e31;
	int I1,I2,I3,I4;
	int i;
	int res;

	res=n0;
	e01=e02=e03=0;

	if ((e[n0]>equi)&&(e[n1]<equi)) e01=1;
	if ((e[n0]<equi)&&(e[n1]>equi)) e01=1;

	if ((e[n0]>equi)&&(e[n2]<equi)) e02=1;
	if ((e[n0]<equi)&&(e[n2]>equi)) e02=1;

	if ((e[n0]>equi)&&(e[n3]<equi)) e03=1;
	if ((e[n0]<equi)&&(e[n3]>equi)) e03=1;

	if (e01+e02+e03==3)
	{
		I1=CalculateIntersectionSegment(N,l,m,n,n0,n1);
		I2=CalculateIntersectionSegment(N,l,m,n,n0,n2);
		I3=CalculateIntersectionSegment(N,l,m,n,n0,n3);
		UploadTriangle(n0,I1,I2,I3);

		return res;
	}


	if (e01+e02+e03==2)
	{
		i=0;
		if ((e01==1)&&(e02==1))
		{
			i++;
			I1=CalculateIntersectionSegment(N,l,m,n,n0,n1);
			I2=CalculateIntersectionSegment(N,l,m,n,n0,n2);
		}
		else
		if ((e02==1)&&(e03==1))
		{
			i++;
			I1=CalculateIntersectionSegment(N,l,m,n,n0,n2);
			I2=CalculateIntersectionSegment(N,l,m,n,n0,n3);
		}
		else
		if ((e03==1)&&(e01==1))
		{
			i++;
			I1=CalculateIntersectionSegment(N,l,m,n,n0,n3);
			I2=CalculateIntersectionSegment(N,l,m,n,n0,n1);
		}

		e12=e23=e31=0;

		if ((e[n1]>equi)&&(e[n2]<equi)) e12=1;
		else
		if ((e[n1]<equi)&&(e[n2]>equi)) e12=1;

		if ((e[n2]>equi)&&(e[n3]<equi)) e23=1;
		else
		if ((e[n2]<equi)&&(e[n3]>equi)) e23=1;

		if ((e[n3]>equi)&&(e[n1]<equi)) e31=1;
		else
		if ((e[n3]<equi)&&(e[n1]>equi)) e31=1;

		e00=0;


		if ((e12==1)&&(e23==1))
		{
			i++;
			e00=n2;
			I3=CalculateIntersectionSegment(N,l,m,n,n1,n2);
			I4=CalculateIntersectionSegment(N,l,m,n,n2,n3);

		}
		else
		if ((e31==1)&&(e23==1))
		{
			i++;
			e00=n3;
			I3=CalculateIntersectionSegment(N,l,m,n,n2,n3);
			I4=CalculateIntersectionSegment(N,l,m,n,n3,n1);

		}
		else
		if ((e31==1)&&(e12==1))
		{
			i++;
			e00=n1;
			I3=CalculateIntersectionSegment(N,l,m,n,n3,n1);
			I4=CalculateIntersectionSegment(N,l,m,n,n1,n2);
		}

		if (i==2)
		{
			UploadTriangle(e00,I1,I2,I3);
			UploadTriangle(e00,I1,I3,I4);
		}

		return e00;
	}

	return res;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSurfaces::chg(int n,int m)
{
	register int xchg[3];

	xchg[0]=pnca0[n];
	xchg[1]=pnca1[n];
	xchg[2]=pnca2[n];
	pnca0[n]=pnca0[m];
	pnca1[n]=pnca1[m];
	pnca2[n]=pnca2[m];
	pnca0[m]=xchg[0];
	pnca1[m]=xchg[1];
	pnca2[m]=xchg[2];
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct
{
	int a,b;
	CVector A,B;
	int tag;

} seg_ss;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int nextA(CVector I,seg_ss * listseg,int nlist);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int nextB(CVector I,seg_ss * listseg,int nlist);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int dead(seg_ss * listseg,int nlist);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CFigure * parse_list_seg_ss(int start,seg_ss * listseg,int nlist,CVector * vertices,int *nv);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool squareintersect(CFigure *f1,CFigure *f2,CVector *vertices);
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CFigure * createshape(CFigure *fig,float X,float Y,float R,CVertex * base,CVector *base_stoks,CVector *base_norms,int *nv,int sens);

extern C3DAPI Render;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSurfaces::Calculate(int N,int minx,int miny,int minz,int maxx,int maxy,int maxz)
{
	const int T[5][4] = { { 4,1,7,2 },{ 0,1,4,2 },{ 5,7,4,1 },{ 3,1,2,7 },{ 6,2,4,7 } };
	const int Sigma[8][4] =	{ { 0,1,2,3 },{ 1,2,0,3 },{ 2,3,0,1 },{ 3,0,2,1 },{ 0,1,2,3 },{ 1,2,3,0 },{ 2,3,0,1 },{ 3,0,1,2 } };
	register int l,n,m;
	register int ml,mn,mm;
	register int i,j;
	int p0[2][2][2][8];
	int p1[2][2][2][8];
	int p2[2][2][2][8];
	int nn;
	CVector p;

	impair=0;

	dimx=(maxx-minx);
	dimy=(maxy-miny);
	dimz=(maxz-minz);

	mx=-minx;
	my=-miny;
	mz=-minz;

	int adr2,temp;
	temp=dimy*dimx;

	news=NULL;

	char * potentiel=(char *) malloc((dimx+1)*(dimy+1)*(dimz+1));

	PLANK=dimx*dimy;

	for (l=minx;l<=maxx;l++)
	{
		for (m=miny;m<=maxy;m++)
		{
			for (n=minz;n<=maxz;n++)
			{
				p.x=(float) (l)*DIVISION;
				p.y=(float) (m)*DIVISION;
				p.z=(float) (n)*DIVISION;				
				potentiel[(l-minx)+(maxx-minx+1)*((m-miny)+(maxy-miny+1)*(n-minz))]=Potentiel(N,&p);
			}
		}
	}

	for (l=0;l<2;l++)
		for (m=0;m<2;m++)
			for (n=0;n<2;n++)
			{
				ml=l&1;
				mm=m&1;
				mn=n&1;
				for (i=0;i<8;i++)
				{
					pnca0[i]=pnc0[i];
					pnca1[i]=pnc1[i];
					pnca2[i]=pnc2[i];
				}

				if (ml==1)
				{
					for (i=0;i<4;i++) chg(i,i+4);
				}

				if (mm==1)
				{
					chg(0,2);chg(1,3);chg(4,6);chg(5,7);
				}

				if (mn==1)
				{
					chg(0,1);chg(2,3);chg(4,5);chg(6,7);
				}
			
				for (i=0;i<8;i++)
				{
					p0[ml][mm][mn][i]=pnca0[i];
					p1[ml][mm][mn][i]=pnca1[i];
					p2[ml][mm][mn][i]=pnca2[i];
				}
			}

	for (l=minx;l<maxx;l++)
	{
		for (m=miny;m<maxy;m++)
		{
			for (n=minz;n<maxz;n++)
			{
				ml=l&1;
				mm=m&1;
				mn=n&1;
				nn=0;
				for (i=0;i<8;i++)
				{
					pnca0[i]=p0[ml][mm][mn][i];
					pnca1[i]=p1[ml][mm][mn][i];
					pnca2[i]=p2[ml][mm][mn][i];
				}

				impair=0;
				if (ml==1)
				{
					impair=(impair+1)&1;
				}

				if (mm==1)
				{
					impair=(impair+1)&1;
				}

				if (mn==1)
				{
					impair=(impair+1)&1;
				}

				for (i=0;i<8;i++)
				{
					pts[i].x=(float) (l+pnca0[i])*DIVISION;
					pts[i].y=(float) (m+pnca1[i])*DIVISION;
					pts[i].z=(float) (n+pnca2[i])*DIVISION;
					e[i]=potentiel[((l+pnca0[i])-minx)+(maxx-minx+1)*(((m+pnca1[i])-miny)+(maxy-miny+1)*((n+pnca2[i])-minz))];
					if (e[i]>equi) nn++;
				}


				if ((nn>0)&&(nn<8))
				{
					if (N<DEPTH)
					{
						int KITER=4;
						DIVISION/=KITER;
						Calculate(N+1,l*KITER,m*KITER,n*KITER,(l+1)*KITER,(m+1)*KITER,(n+1)*KITER);
						DIVISION*=KITER;
					}
					else
					{
						for (i=0;i<8;i++)
							for (j=i;j<8;j++)
							{
								Segments[i][j]=-1;
								Segments[j][i]=-1;
							}

						for (i=0;i<5;i++)
						{
							for (j=0;j<4;j++)
							{
								CalcTetrahedron(N,l,m,n,T[i][Sigma[j][0]],
											   T[i][Sigma[j][1]],
											   T[i][Sigma[j][2]],
											   T[i][Sigma[j][3]]);

							}
						}
					}
				}
			}
		}
	}

	free(potentiel);

	if (N==0)
	{
		if ((nVertices>0)&&(nFaces>0))
		{
			OBJ.Init(nVertices,nFaces);
			status=1;

			for (n=0;n<nVertices;n++)
				OBJ.Vertices[n].Stok=Vertices[n];

			for (n=0;n<nFaces;n++)
				OBJ.Faces[n].Init(Faces[0][n],Faces[2][n],Faces[1][n]);

			OBJ.Coo.Init(0,0,0);
			OBJ.nFaces=nFaces;
			OBJ.nVertices=nVertices;
			sprintf(OBJ.Name,"Surfaces");
			OBJ.SetFaces();
			OBJ.Radius=-1;
		}
		else
		{
			OBJ.nFaces=0;
			OBJ.nVertices=0;
		}
	}

	return (maxx-minx)*(maxy-miny)*(maxz-minz);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSurfaces::Free()
{
	delete [] Vertices;
	delete [] Faces[0];
	delete [] Faces[1];
	delete [] Faces[2];
	status=0;
	OBJ.Free();
	potentiel_xyz=NULL;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
