////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//	  <3D Librairies developped during 2002-2008>
//	  Copyright (C) <2008>  <Laurent Canc Francis, 10/08/1975>
//	  laurentcance@free.fr
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////
//	@file surfaces.h
//	@author Laurent Cance <laurentcance@free.fr>
//	@copyright 2010
//	@created 2002
//	@date 2010-03-18
//	$Author: laurent canc francis $
//	$Revision: XX $
//////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _SURFACES_H_
#define _SURFACES_H_

#include "../lib3d/base/maths.h"
#include "../lib3d/base/objects3d.h"
#include "../lib3d/base/3d_api_base.h"
#include "../lib3d/misc/metaballs.h"

#define LIMITE 100000


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Ball
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Metaballs mesh generator
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CSurfaces
{
public:
	float small_float;
	float equi;
	int varx,vary,varz,varf;
	bool vertexbuffer_update;
	int * potentiel_xyz;
	bool ENVMAPPING;
	CObject3D OBJ;
	CVertexBuffer VB;
	CVector Pos;
	int posVertices;
	//int minx,miny,minz,maxx,maxy,maxz;
	float minx0,miny0,minz0,maxx0,maxy0,maxz0;  
	int Segments[8][8];
	int tSegments[8][8];
	int tSegments2[8][8];
	int impair;
	int Orientation;
	int pnca0[8];
	int pnca1[8];
	int pnca2[8];
	int pnca3[8];
	int * news;
	int mx,my,mz;
	bool wait;
	int tag[8];
	CVector pts[8];
	float e[8];
	CVector* Vertices;
	int * segments;
	int nVertices;
	int * Faces[3];
	int nFaces;
	int dimx,dimy,dimz;
	float SCALING;
	float DIVISION;
	int segm0[12];
	int segm1[12];
	int pnc0[8];
	int pnc1[8];
	int pnc2[8];
	int pnc3[8];
	int status;

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// constructor

	CSurfaces() 
	{ 
		vertexbuffer_update=true;
		nFaces=0;nVertices=0;Orientation=1;
		status=0;
		ENVMAPPING=true;
		wait=true;
		potentiel_xyz=NULL;

		Vertices=NULL;
		Faces[0]=NULL;
		Faces[1]=NULL;
		Faces[2]=NULL;
	}

	
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// interaction with procdures

		bool Init(char * function);
		void Free();
		void AddMetaball(CVector pos,float pot);
		void SubMetaball(CVector pos,float pot);
		void SetEquipotentielle(float e,float precision);
		int Calculate(int N,int minx,int miny,int minz,int maxx,int maxy,int maxz);
	
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// internals
	
		int UploadVertices(CVector *A);

		CVector Gradiant(CVector *A);
				
		float Potentiel(int N,CVector *u);
		int EquiPotentielle(int N,CVector *A,CVector *B,float pA,float pB);

		int CalcTetrahedron(int N,int l,int m,int n,int n0,int n1,int n2,int n3);
		int CalculateIntersectionSegment(int N,int l,int m,int n,int n0,int n1);
		void UploadTriangle(int ref,int A,int B,int C);
				
		void chg(int n,int m);

	
};

#endif
